/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bmepsgui;
import java.util.prefs.Preferences;
import java.util.ArrayList;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.IOException;

/**
 *
 * @author krause
 */
public class BmepsController {

  /** Option key words */
  public static final String[] okw = {
    /*   0 */	"-l",
    /*   1 */	"eps",
    /*   2 */	"pdf",
    /*   3 */	"bb",
    /*   4 */	",",
    /*   5 */	",l=",
    /*   6 */	"1",
    /*   7 */	"2",
    /*   8 */	"3",
    /*   9 */	"1.2",
    /*  10 */	"1.3",
    /*  11 */	"1.4",
    /*  12 */	"ps",
    /*  13 */	"y",
    /*  14 */	"n",
    /*  15 */	",dsc.c=",
    /*  16 */	",c=",
    /*  17 */	",o.d=y",
    /*  18 */	",e=f:d:a",
    /*  19 */	",e=",
    /*  20 */	"a",
    /*  21 */	"r",
    /*  22 */	"d",
    /*  23 */	"f",
    /*  24 */	":",
    /*  25 */	",m.d.s=",
    /*  26 */	",j.s.s=",
    /*  27 */	"-",
    /*  28 */	",s.d=",
    /*  29 */	",v=",
    /*  30 */	",sh=",
    /*  31 */	",i=",
    /*  32 */	",j.i=",
    /*  33 */	",m=",
    /*  34 */	",b=",
    /*  35 */	",a.u.d.b=",
    /*  36 */	",c.i.m=",
    /*  37 */	",i.m.t.l=",
    /*  38 */	"0.0001221",
    /*  39 */	"0.9998779",
    /*  40 */	",u.r.c=y",
    /*  41 */	",m.s=",
    /*  42 */	",p.f=width",
    /*  43 */	",p.f=height",
    /*  44 */	",p.f=page",
    /*  45 */	",t.a.c=y",
    /*  46 */	",a.p.p.a=",
    /*  47 */	",d=",
  };


  public static String[] outputSuffixes = {
    ".bb", ".ps", ".eps", ".pdf"
  };

  /** PS level 1 */
  public static final int PS_1 = 0;

  /** PS level 2 */
  public static final int PS_2 = 1;

  /** PS level 3 */
  public static final int PS_3 = 2;

  /** PDF level 1.2 */
  public static final int PDF_12 = 0;

  /** PDF level 1.3 */
  public static final int PDF_13 = 1;

  /** PDF level 1.4 */
  public static final int PDF_14 = 2;

  /** default configuration normally built-in in bmeps */
  public static final String[] defaultPredefinedConfigurations = {
    "ps1", "ps2", "ps3", "eps1", "eps2", "eps3", "pdf12", "pdf13", "pdf14",
    "ps", "eps", "pdf", "faxps", "faxpdf", "bb"
  };

  /** configuration names built-in in bmeps source code */
  protected String[] predefConf = null;
  
  /** By default the list of config-file configurations is empty */
  public static final String[] defaultFileConfigurations = {};

  /** additional configurations defined in bmeps.conf */
  protected String[] fileConf = null;

  /** String settings preferences keys */
  protected String[] sPrefKeys = {
    "directory",	//  0
  };
  
  /** String settings */
  protected String[] sv = {
    ".",	// 0: current working directory
  };

  /**
   * Retrieve one string entry.
   *
   * @param n
   * Index in the array.
   *
   * @return
   * The entry at position n.
   */
  public synchronized String getString(int n) {
    String back; back = sv[n]; return back;
  }

  /**
   * Set one string entry.
   *
   * @param n
   * The index of the entry to set.
   *
   * @param x
   * The new value.
   */
  public synchronized void setString(int n, String x) {
    sv[n] = x;
  }

  /** Boolean settings preferences keys */
  protected String[] bPrefKeys = {
    "conf.full-custom",	//  0
    "ps.encapsulated",	//  1
    "ps.dsc",		//  2
    "ps.color",		//  3
    "handle-png",	//  4
    "handle-jpeg",	//  5
    "handle-netpbm",	//  6
    "handle-tiff",	//  7
    "conf.built-in",	//  8
    "ps.interpolate",	//  9
    "ps.interpolate.jpg",	// 10
    "pdf.interpolate",	// 11
    "pdf.interpolate.jpg",	// 12
    "ps.mix",		// 13
    "ps.prefer.default",	// 14
    "ps.mask",		// 15
    "ps.dictionary",	// 16
    "ps.vmreclaim",	// 17
    "ps.showpage",	// 18
    "ps.ascii85",	// 19
    "ps.run-length",	// 20
    "ps.run-length.multi",	// 21
    "ps.flate",		// 22
    "ps.dct",		// 23
    "ps.dct.sof00",	// 24
    "ps.dct.sof01",	// 25
    "ps.dct.sof02",	// 26
    "ps.dct.sof03",	// 27
    "ps.dct.sof04",	// 28
    "ps.dct.sof05",	// 29
    "ps.dct.sof06",	// 30
    "ps.dct.sof07",	// 31
    "ps.dct.sof08",	// 32
    "ps.dct.sof09",	// 33
    "ps.dct.sof10",	// 34
    "ps.dct.sof11",	// 35
    "ps.dct.sof12",	// 36
    "ps.dct.sof13",	// 37
    "ps.dct.sof14",	// 38
    "ps.dct.sof15",	// 39
    "pdf.transfer-alpha",	// 40
    "pdf.mix",		// 41
    "pdf.prefer-default-bg",	// 42
    "pdf.mask",		// 43
    "pdf.mask.highlevel",	// 44
    "pdf.dct.sof00",	// 45
    "pdf.dct.sof01",	// 46
    "pdf.dct.sof02",	// 47
    "pdf.dct.sof03",	// 48
    "pdf.dct.sof04",	// 49
    "pdf.dct.sof05",	// 50
    "pdf.dct.sof06",	// 51
    "pdf.dct.sof07",	// 52
    "pdf.dct.sof08",	// 53
    "pdf.dct.sof09",	// 54
    "pdf.dct.sof10",	// 55
    "pdf.dct.sof11",	// 56
    "pdf.dct.sof12",	// 57
    "pdf.dct.sof13",	// 58
    "pdf.dct.sof14",	// 59
    "pdf.dct.sof15",	// 60
    "pdf.page-attributes",	// 61
    "log.always",	// 62
    "draft",		// 63
    "case-sensitive",	// 64, overwritten by bmeps --configuration-file
    "make-mode",	// 65 make mode
    "ps.force-dct",	// 66 force DCT for PS
    "pdf.force-dct",	// 67 force DCT for PDF
  };
  
  /** Boolean settings */
  protected boolean[] bv = {
    false,	//  0: use full-custom configuration
    false,	//  1: PS: use encapsulated PS
    false,	//  2: PS: DSC comments
    true,	//  3: PS: colored
    true,	//  4: can handle PNG
    true,	//  5: can handle JPEG
    true,	//  6: can handle NetPbm
    true,	//  7: can handle TIFF
    true,	//  8: use built-in configuration
    true,	//  9: interpolate (PS)
    false,	// 10: interploate JPEG (PS)
    true,	// 11: interpolate (PDF)
    false,	// 12: interpoloate JPEG (PDF)
    true,	// 13: mix alpha (PS)
    true,	// 14: prefer def bg (PS)
    false,	// 15: image mask (PS)
    true,	// 16: PS dictionary
    false,	// 17: PS vmreclaim
    false,	// 18: PS showpage
    true,	// 19: PS ASCII85
    true,	// 20: PS run-length
    true,	// 21: PS run-length, multiple data sources
    false,	// 22: PS flate
    true,	// 23: PS DCT
    true,	// 24
    true,	// 25
    false,	// 26
    false,	// 27
    false,	// 28
    false,	// 29
    false,	// 30
    false,	// 31
    false,	// 32
    false,	// 33
    false,	// 34
    false,	// 35
    false,	// 36
    false,	// 37
    false,	// 38
    false,	// 39
    true,	// 40: PDF transfer alpha
    true,	// 41: PDF mix
    false,	// 42: PDF prefer default bg
    false,	// 43: PDF create mask
    false,	// 44: PDF high trigger level
    true,	// 45: PDF DCT SOF 0
    true,	// 46
    false,	// 47
    false,	// 48
    false,	// 49
    false,	// 50
    false,	// 51
    false,	// 52
    false,	// 53
    false,	// 54
    false,	// 55
    false,	// 56
    false,	// 57
    false,	// 58
    false,	// 59
    false,	// 60: PDF DCT SOF 15
    true,	// 61: allow PDF page attributes
    false,	// 62: always open log
    false,	// 63: draft mode
    true,	// 64: case-senstive
    true,	// 65: make mode
    false,	// 66: Force PS DCT
    false,	// 67: Force PDF DCT
  };

  /**
   * Retrieve one boolean entry.
   *
   * @param n
   * Index in the array.
   *
   * @return
   * The entry at position n.
   */
  public synchronized boolean getBoolean(int n) {
    boolean back; back = bv[n]; return back;
  }

  /**
   * Set one boolean entry.
   *
   * @param n
   * The index of the entry to set.
   *
   * @param x
   * The new value.
   */
  public synchronized void setBoolean(int n, boolean x) {
    bv[n] = x;
  }

  /** Integer settings preferences keys */
  protected String[] iPrefKeys = {
    "ps.level",			//  0
    "pdf.level",		//  1
    "conf.which-builtin",	//  2
    "conf.which-from-file",	//  3
    "eps.mix.red",		//  4
    "eps.mix.green",		//  5
    "eps.mix.blue",		//  6
    "pdf.mix.red",		//  7
    "pdf.mix.green",		//  8
    "pdf.mix.blue",		//  9
    "conf.base",		// 10
    "eps.mask",			// 11
    "eps.size",			// 12
    "eps.paper",		// 13
    "pdf.fit",			// 14
    "pdf.size",			// 15
    "pdf.paper",		// 16
  };

  /** Integer settings */
  protected int[] iv = {
    PS_2,	//  0: PS level
    PDF_14,	//  1: PDF level
    5,		//  2: which built-in configuration
    0,		//  3: which file configuration
    255,	//  4: R(EPS)
    255,	//  5: G(EPS)
    255,	//  6: B(EPS)
    255,	//  7: R(PDF)
    255,	//  8: G(PDF)
    255,	//  9: B(PDF)
    0,		// 10: which base configuration
    0,		// 11: PS mask level index
    0,		// 12: PS size setting
    0,		// 13: PS paper size index
    0,		// 14: PDF fit index
    0,		// 15: PDF size index
    0,		// 16: PDF paper size index
  };

  /**
   * Retrieve one integer entry.
   *
   * @param n
   * Index in the array.
   *
   * @return
   * The entry at position n.
   */
  public synchronized int getInt(int n) {
    int back; back = iv[n]; return back;
  }

  /**
   * Set one string entry.
   *
   * @param n
   * The index of the entry to set.
   *
   * @param x
   * The new value.
   */
  public synchronized void setInt(int n, int x) {
    iv[n] = x;
  }
  
  /** command line to make bmeps show the config file */
  public static final String[] cmdToReadConfigFile = {
    "bmeps",
    "--configuration-file",
    "--/ui/lang=en",
    "--/ui/lang/env=no",
    "--/log/stdout/level=none",
    "--/log/stderr/level=none",
    "--/log/file/level=none"
  };
   
  
  
  /** command line to show version */
  public static final String[] cmdToShowVersion = {
    "bmeps",
    "--version",
    "--/ui/lang=en",
    "--/ui/lang/env=no",
    "--/log/stdout/level=none",
    "--/log/stderr/level=none",
    "--/log/file/level=none"
  };



  /** command to convert two files */
  public static final String[] cmdToConvert = {
    "bmeps",
    "--/ui/lang=en",
    "--/ui/lang/env=no",
    "--/log/stdout/level=progress",
    "--/log/stderr/level=none",
    "--/log/file/level=non",
    "--/log/stdout/time=yes",
    "--/log/stdout/split=yes"
  };

  
  public BmepsController() {
  }
  
  /**
   * Attempt to read settings from preferences.
   */
  void init() {
    int i;
    processBmepsConfigurationFile();
    Preferences userPrefs = Preferences.userRoot().node(BGS.prefNode);
    for(i = 0; i < bv.length; i++) {
      try {
        boolean b = userPrefs.getBoolean(bPrefKeys[i], bv[i]);
	bv[i] = b;
      } catch(RuntimeException e) {}
    }
    for(i = 0; i < iv.length; i++) {
      try {
        int k = userPrefs.getInt(iPrefKeys[i], iv[i]);
	iv[i] = k;
      } catch(RuntimeException e) {}
    }
    for(i = 0; i < sv.length; i++) {
      try {
        String s = userPrefs.get(sPrefKeys[i], sv[i]);
	sv[i] = s;
      } catch(RuntimeException e) {}
    }
  }
  

  /**
   * Attempt to save settings to preferences.
   */
  void save() {
    int i;
    Preferences userPrefs = Preferences.userRoot().node(BGS.prefNode);
    for(i = 0; i < sv.length; i++) {
      try {
        userPrefs.put(sPrefKeys[i], sv[i]);
      } catch(RuntimeException e) {}
    }
    for(i = 0; i < iv.length; i++) {
      try {
	userPrefs.putInt(iPrefKeys[i], iv[i]);
      } catch(RuntimeException e) {}
    }
    for(i = 0; i < bv.length; i++) {
      try {
        userPrefs.putBoolean(bPrefKeys[i], bv[i]);
      } catch(RuntimeException e) {}
    }
  }
  


  /**
   * Create a string array from an array list.
   *
   * @param a
   * The array list.
   *
   * @return
   * An array of strings.
   */
  private String[] arrayListToStringArray(ArrayList<String> a) {
    int i = 0;
    Object o[] = a.toArray();
    String[] back = new String[o.length];
    for(i = 0; i < o.length; i++) {
      back[i] = new String((String)(o[i]));
    }
    return back;
  }
  
  
  
  /**
   * Run bmeps --configuration-file to find the predefined configuration
   * names.
   */
  private void processBmepsConfigurationFile() {
    int state = 0;
    int i1 = 0, i2 = 0;
    ArrayList<String> c_b = new ArrayList<String>();
    ArrayList<String> c_f = new ArrayList<String>();
    try {
      String s;
      Process p = Runtime.getRuntime().exec(cmdToReadConfigFile);
      InputStreamReader isr = new InputStreamReader(p.getInputStream());
      BufferedReader in = new BufferedReader(isr);
      while((s = in.readLine()) != null) {
        i1 = s.indexOf('#');
        if(i1 >= 0) {
          if(s.contains("@BUILT-IN")) {
            state = 1;
          } else {
            if(s.contains("@CONFIG-FILE")) {
              state = 2;
            } else {
	      if(s.contains("@PLATFORM")) {
	        if(s.contains("filename")) {
		  if(s.contains("case-sensitive")) {
		    bv[64] = true;
		  } else {
		    if(s.contains("case-insensitive")) {
		      bv[64] = false;
		    }
		  }
		} else {
		}
	      }
	    }
          }
        } else {
          i1 = s.indexOf('[');
          if(i1 >= 0) {
            i2 = s.indexOf(']');
            if(i2 >= 0) {
              s = s.substring(i1+1,i2);
              i1 = s.indexOf(':');
              if(i1 >= 0) {
                s = s.substring(0, i1);
              }
              switch(state) {
                case 1: {
                  c_b.add(s);
                } break;
                case 2: {
                  c_f.add(s);
                } break;
              }
            }
          }
        }
      }
      in.close(); in = null; isr = null;
      isr = new InputStreamReader(p.getErrorStream());
      in = new BufferedReader(isr);
      while((s = in.readLine()) != null) { }
      in.close(); in = null; isr = null;
      predefConf = arrayListToStringArray(c_b);
      fileConf = arrayListToStringArray(c_f);
    }
    catch(IOException e) {
      predefConf = defaultPredefinedConfigurations;
      fileConf = defaultFileConfigurations;
    }
    if(predefConf == null) { predefConf = defaultPredefinedConfigurations; }
    if(fileConf == null) { fileConf = defaultFileConfigurations; }
    try {
      Process p = Runtime.getRuntime().exec(cmdToShowVersion);
      InputStreamReader isr = new InputStreamReader(p.getInputStream());
      BufferedReader in = new BufferedReader(isr);
      String s;
      while((s = in.readLine()) != null) {
        if(s.indexOf(BGS.lt[88]) != -1) {
	  setBoolean(4, false); setBoolean(5, false);
	  setBoolean(6, false); setBoolean(7, false);
	  if(s.indexOf(BGS.lt[89]) != -1) {
	    setBoolean(4, true);
	  }
	  if(s.indexOf(BGS.lt[90]) != -1) {
	    setBoolean(5, true);
	  }
	  if(s.indexOf(BGS.lt[91]) != -1) {
	    setBoolean(6, true);
	  }
	  if(s.indexOf(BGS.lt[92]) != -1) {
	    setBoolean(7, true);
	  }
	}
      }
      in.close(); in = null; isr = null;
      isr = new InputStreamReader(p.getErrorStream());
      in = new BufferedReader(isr);
      while((s = in.readLine()) != null) {}
      in.close(); in = null; isr = null;
    } catch(IOException e) {}
  }



  void cloneFrom(BmepsController orig) {
    int i = 0;
    predefConf = orig.predefConf;
    fileConf = orig.fileConf;
    for(i = 0; i < sv.length; i++) {
      sv[i] = orig.getString(i);
    }
    for(i = 0; i < bv.length; i++) {
      bv[i] = orig.getBoolean(i);
    }
    for(i = 0; i < iv.length; i++) {
      iv[i] = orig.getInt(i);
    }
  }



  private void addEncoding(StringBuilder sb, boolean isPdf) {
    boolean isFirst = true;
    int i;
    if(isPdf) {
      sb.append(okw[18]);
    } else {
      sb.append(okw[19]);
      if(bv[19]) {			// A85
	sb.append(okw[20]);
	isFirst = false;
      }
      if(bv[20]) {			// run-length
        if(isFirst) { sb.append(okw[19]); } else { sb.append(okw[24]); }
	sb.append(okw[21]);
	isFirst = false;
      }
      if(bv[23]) {			// DCT
        if(isFirst) { sb.append(okw[19]); } else { sb.append(okw[24]); }
	sb.append(okw[22]);
	isFirst = false;
      }
      if((iv[0] > 1) && bv[22]) {	// flate
        if(isFirst) { sb.append(okw[19]); } else { sb.append(okw[24]); }
	sb.append(okw[23]);
	isFirst = false;
      }
      if(bv[20]) {		// multiple data sources
        sb.append(okw[25]); sb.append(okw[(bv[21]) ? 13 : 14]);
      }
    }
    if(isPdf || bv[23]) {		// JFIF SOF set
      isFirst = true;
      sb.append(okw[26]);
      for(i = 0; i < 16; i++) {
        if(bv[(isPdf) ? (45 + i) : (23 + i)]) {
	  if(!isFirst) {
	    sb.append(okw[24]);
	  }
	  sb.append((new Integer(i)).toString());
	  isFirst = false;
	}
      }
      if(isFirst) { sb.append(okw[27]); }
    }
  }



  private String colorToDouble(int colorvalue) {
    double dvalue = (double)colorvalue / 255.0;
    dvalue = 0.001 * Math.rint(1000.0 * dvalue);
    return ((new Double(dvalue)).toString());
  }



  private void createEpsOptionsString(StringBuilder sb) {
    // level
    sb.append(okw[5]);
    switch(iv[0]) {
      case 0: { sb.append(okw[6]); } break;
      case 1: { sb.append(okw[7]); } break;
      default: { sb.append(okw[8]); } break;
    }
    // image size
    switch(iv[12]) {
      case 2: {		// paper size
        sb.append(okw[41]);
	sb.append(BGS.paperSizes[iv[13]]);
      } break;
      case 1: {		// resolution chunk
        sb.append(okw[40]);
      } break;
    }
    // draft
    sb.append(okw[47]); sb.append(okw[(bv[63]) ? 13 : 14]);
    if(!bv[63]) {
      // DSC
      sb.append(okw[15]); sb.append(okw[(bv[2]) ? 13 : 14]);
      if(iv[0] > 0) {
        // colored
        sb.append(okw[16]); sb.append(okw[(bv[3]) ? 13 : 14]);
        // operator dictionary
        sb.append(okw[17]);
        // encoding, multiple data sources, sofs
        addEncoding(sb, false);
        // separated dictionary
        sb.append(okw[28]); sb.append(okw[(bv[16]) ? 13 : 14]);
        // vmreclaim
        sb.append(okw[29]); sb.append(okw[(bv[17]) ? 13 : 14]);
        // showpage
        sb.append(okw[30]); sb.append(okw[(bv[19]) ? 13 : 14]);
        // image interpolation normal
        sb.append(okw[31]); sb.append(okw[(bv[9]) ? 13 : 14]);
        // image interpolation JPEG
        if(bv[9]) {
          sb.append(okw[32]); sb.append(okw[(bv[10]) ? 13 : 14]);
        }
        // alpha mixing, background, prefer
        sb.append(okw[33]); sb.append(okw[(bv[13]) ? 13 : 14]);
        if(bv[13]) {
          sb.append(okw[34]);
	  sb.append(colorToDouble(iv[4]));
	  sb.append(okw[24]);
	  sb.append(colorToDouble(iv[5]));
	  sb.append(okw[24]);
	  sb.append(colorToDouble(iv[6]));
	  sb.append(okw[35]); sb.append(okw[(bv[14]) ? 13 : 14]);
        }
        if(iv[0] > 1) {
          // alpha mask, mask level
	  sb.append(okw[36]); sb.append(okw[(bv[15]) ? 13 : 14]);
	  if(bv[15]) {
	    sb.append(okw[37]); sb.append(okw[(iv[11] > 0) ? 39 : 38]);
	  }
        }
      }
    }
  }

  private void createPdfOptionsString(StringBuilder sb) {
    sb.append(okw[5]);
    switch(iv[1]) {
      case 0: { sb.append(okw[9]); } break;
      case 1: { sb.append(okw[10]); } break;
      default: { sb.append(okw[11]); } break;
    }
    switch(iv[14]) {
      case 1: {
        sb.append(okw[42]);
      } break;
      case 2: {
        sb.append(okw[43]);
      } break;
      case 3: {
        sb.append(okw[44]);
      } break;
    }
    switch(iv[15]) {
      case 1: {
        sb.append(okw[40]);
      } break;
      case 2: {
        sb.append(okw[41]);
	sb.append(BGS.paperSizes[iv[16]]);
      } break;
    }
    sb.append(okw[47]); sb.append(okw[(bv[63]) ? 13 : 14]);
    if(!bv[63]) {
      sb.append(okw[31]); sb.append(okw[(bv[11]) ? 13 : 14]);
      if(bv[11]) {
        sb.append(okw[32]); sb.append(okw[(bv[12]) ? 13 : 14]);
      }
      if((iv[1] > 1) && (bv[40])) {
        sb.append(okw[45]);
        sb.append(okw[46]); sb.append(okw[(bv[61]) ? 13 : 14]);
      } else {
        sb.append(okw[33]); sb.append(okw[(bv[41]) ? 13 : 14]);
        if(bv[41]) {
          sb.append(okw[34]);
	  sb.append(colorToDouble(iv[7]));
	  sb.append(okw[24]);
	  sb.append(colorToDouble(iv[8]));
	  sb.append(okw[24]);
	  sb.append(colorToDouble(iv[9]));
	  sb.append(okw[35]); sb.append(okw[(bv[42]) ? 13 : 14]);
        }
        sb.append(okw[36]); sb.append(okw[(bv[43]) ? 13 : 14]);
        if(bv[43]) {
	  sb.append(okw[37]); sb.append(okw[(bv[44]) ? 39 : 38]);
        }
      }
      addEncoding(sb, true);
    }
  }
  
  
  
  protected String createOptionsString() {
    StringBuilder sb = new StringBuilder();
    if(bv[0]) {	// full custom
      sb.append(okw[0]);
      switch(iv[10]) {
        case 2: {	// bb
	  sb.append(okw[3]);
	} break;
	case 1: {	// pdf
	  sb.append(okw[2]);
	  createPdfOptionsString(sb);
	} break;
	default: {	// eps
	  sb.append(okw[(bv[1]) ? 1 : 12]);
	  createEpsOptionsString(sb);
	} break;
      }
    } else {		// configuration from bmeps.conf
      sb.append(okw[0]);
      if(bv[8]) {	// built-in cofiguration
	sb.append(predefConf[iv[2]]);
      } else {	// file configuration
        sb.append(fileConf[iv[3]]);
      }
    }
    return (new String(sb));
  }



  protected String getOutputSuffix() {
    String back = outputSuffixes[1];
    if(bv[0]) {		// full-custom
      switch(iv[10]) {
        case 1: {					// PDF
	  back = outputSuffixes[3];
	} break;
	case 2: {					// BB
	  back = outputSuffixes[0];
	} break;
	default: {					// PS/EPS
	  back = outputSuffixes[(bv[1]) ? 2 : 1];
	} break;
      }
    } else {
      if(bv[8]) {	
        switch(iv[2]) {	// built-in
	  case 4: case 5: case 6: case 7: {		// EPS
	    back = outputSuffixes[2];
	  } break;
	  case 9: case 10: case 11: case 12: case 13: {	// PDF
	    back = outputSuffixes[3];
	  } break;
	  case 14: {					// BB
	    back = outputSuffixes[0];
	  } break;
	}
      } else {
	if(fileConf != null) {
	  if(iv[3] < fileConf.length) {
	    if(fileConf[iv[3]].startsWith("pdf")) {
	      back = outputSuffixes[3];
	    }
	    if(fileConf[iv[3]].startsWith("bb")) {
	      back = outputSuffixes[0];
	    }
	    if(fileConf[iv[3]].startsWith("eps")) {
	      back = outputSuffixes[2];
	    }
	  }
	}
      }
    }
    return back;
  }



}



// vim: set ai sw=2 :
// project bmeps
// @(#)BmepsController.java 1.4 10/28/09

