/*
Copyright (c) 2001-2008, Dirk Krause
All rights reserved.

Redistribution and use in source and binary forms,
with or without modification, are permitted provided
that the following conditions are met:

* Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.
* Redistributions in binary form must reproduce the above
  opyright notice, this list of conditions and the following
  disclaimer in the documentation and/or other materials
  provided with the distribution.
* Neither the name of the Dirk Krause nor the names of
  its contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE.
*/

package dirk_krause.jtools;

// jlayout.import.begin
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Dimension;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowListener;
import java.awt.event.ItemListener;
import javax.swing.JComponent;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import javax.swing.WindowConstants;
import javax.swing.SwingConstants;
// END OF JLAYOUT SECTION
// jlayout.import.end

import java.awt.Font;
import javax.swing.JFrame;
import dirk_krause.jtools.GuiController;
import dirk_krause.jtools.SelfPositioningDialog;



/**
 * Dialog to set GUI options.
 */
public class GuiDialog extends SelfPositioningDialog
	implements ActionListener, WindowListener, ItemListener
{
  /** Controller for GUI */
  private GuiController guic = null;

  /** Border between GUI compoents */
  private int componentBorder = 5;

  /** Texts for labels... */
  public static final String[] lt = {
    /*  0 */	"GUI options",
    /*  1 */	"Look-and-feel:",
    /*  2 */	"Component border:",
    /*  3 */	"5",
    /*  4 */	"Minimum font size:",
    /*  5 */	"15",
    /*  6 */	"Replace font family",
    /*  7 */	"Dialog",
    /*  8 */	"Sans",
    /*  9 */	"by",
    /* 10 */	"Original fonts:",
    /* 11 */	"",
    /* 12 */	"Fonts in use:",
    /* 13 */
    "You need to restart the application to make the changes visible.",
    /* 14 */	"Use settings for all applications",
    /* 15 */	"Choose a Look-and-Feel from the list.",
    /* 16 */
    "Specify the number of pixel for space between GUI compoents.",
    /* 17 */
    "Decide whether or not to require a minimum font size.",
    /* 18 */
    "Specify the number of pixels for the minimum font size.",
    /* 19 */
    "Decide whether or not to replace a font family completely.",
    /* 20 */
    "Specify the name of the font family to replace.",
    /* 21 */
    "Specify the name of the font family to use.",
    /* 22 */
    "This is the list of fonts used by default.",
    /* 23 */
    "This is the list of fonts used after modifications.",
    /* 24 */
    "Decide whether or not to use these settings as defaults for applications not yet configured.",
    /* 25 */
    "Apply the settings made in this dialog box.",
    /* 26 */
    "Discard the settings made in this dialog box.",
    /* 27 */
    "Load current program settings into this dialog box.",
    /* 28 */
    "Suggest reasonable defaults.",
  };

  /** Action commands */
  public static final String[] ac = {
    "OK", "Cancel", "Reset", "Defaults"
  };

  /** Names for LAFs */
  public static final String[] lafNames = {
    "System look-and-feel",
    "No specific look-and-feel (Java-internal)"
  };

// jlayout.variables.begin
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	private int jLayoutSizeMinX = 0;
	private int jLayoutSizeMinY = 0;
	private int jLayoutSizePrefX = 0;
	private int jLayoutSizePrefY = 0;
	private int jLayoutSizeMaxX = 0;
	private int jLayoutSizeMaxY = 0;
	JButton bCancel = null;
	JButton bDefaults = null;
	JButton bOK = null;
	JButton bReset = null;
	JComboBox cbChooseLaf = null;
	JCheckBox cbMinimumFontSize = null;
	JCheckBox cbReplaceFont = null;
	JCheckBox cbUseForAll = null;
	JLabel lBy = null;
	JLabel lChooseLaf = null;
	JLabel lComponentBorder = null;
	JLabel lFontsInUse = null;
	JLabel lFontsOrig = null;
	JLabel lRestartApplication = null;
	JPanel pButtons = null;
	JTextField tfComponentBorder = null;
	JTextField tfFontNew = null;
	JTextField tfFontOld = null;
	JLabel tfFontsInUse = null;
	JLabel tfFontsOrig = null;
	JTextField tfMinimumFontSize = null;
// END OF JLAYOUT SECTION
// jlayout.variables.end

// jlayout.setup.begin
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	/**
	 * Reset the stored size informatio.
	 */
	private void jLayoutResetSizes()
	{
	  jLayoutSizeMinX = 0; jLayoutSizeMinY = 0;
	  jLayoutSizeMaxX = 0; jLayoutSizeMaxY = 0;
	  jLayoutSizePrefX = 0; jLayoutSizePrefY = 0;
	}
	private void jLayoutGetSize(JComponent c)
	{
	  Dimension d;
	  d = c.getMinimumSize();
	  if(d.width > jLayoutSizeMinX) { jLayoutSizeMinX = d.width; }
	  if(d.height > jLayoutSizeMinY) { jLayoutSizeMinY = d.height; }
	  d = c.getPreferredSize();
	  if(d.width > jLayoutSizePrefX) { jLayoutSizePrefX = d.width; }
	  if(d.height > jLayoutSizePrefY) { jLayoutSizePrefY = d.height; }
	  d = c.getMaximumSize();
	  if(d.width > jLayoutSizeMaxX) { jLayoutSizeMaxX = d.width; }
	  if(d.height > jLayoutSizeMaxY) { jLayoutSizeMaxY = d.height; }
	}
	/**
	 * Set a components size to a given minimum (save as other
	 * components).
	 *
	 * @param c
	 * The component to change.
	 */
	private void jLayoutSetSize(JComponent c)
	{
	  c.setMinimumSize(new Dimension(jLayoutSizeMinX, jLayoutSizeMinY));
	  c.setPreferredSize(new Dimension(jLayoutSizePrefX, jLayoutSizePrefY));
	  c.setMaximumSize(new Dimension(jLayoutSizeMaxX, jLayoutSizeMaxY));
	}
	/**
	 * Create GridBag constraints for a component.
	 *
	 * @param x
	 * The start grid column of the component.
	 *
	 * @param y
	 * The start grid line of the component.
	 *
	 * @param w
	 * The width of the component in grid columns.
	 *
	 * @param h
	 * The height of the component in grid lines.
	 *
	 * @param f
	 * The fill information (horizontal, vertical, both).
	 *
	 * @param wx
	 * The weight factor to grow the component horizontally
	 * when the container grows.
	 *
	 * @param wy
	 * The weight factor to grow the component vertically
	 * when the container grows.
	 */
	private GridBagConstraints jLayoutGbc(
	  int x, int y, int w, int h, int f, int a, double wx, double wy
	) {
	  GridBagConstraints back = new GridBagConstraints();
	  back.gridx = x;
	  back.gridy = y;
	  back.gridwidth = w;
	  back.gridheight = h;
	  back.fill = f;
	  back.anchor = a;
	  back.weightx = wx;
	  back.weighty = wy;
	  return back;
	}
	/**
	 * Create a dummy panel to ensure minimum distances.
	 *
	 * @param b
	 * The panels width and hight.
	 *
	 * @param rms
	 * A flag to indicate whether or not the panel must
	 * be set exactly to the given size (The panel can not grow).
	 */
	protected JPanel jLayoutCreateDistancePanel(int b, boolean rms)
	{
	  JPanel back = new JPanel();
	  Dimension d = new Dimension(b, b);
	  back.setMinimumSize(d);
	  back.setPreferredSize(d);
	  if(rms) {
	    back.setMaximumSize(d);
	  }
	  return back;
	}
	private void jLayoutSetup()
	{
	  // bCancel 109
	  bCancel = new JButton(ac[1]);
	  bCancel.setToolTipText(lt[26]);
	  bCancel.getAccessibleContext().setAccessibleDescription(
	    lt[26]
	  );
	  // bDefaults 111
	  bDefaults = new JButton(ac[3]);
	  bDefaults.setToolTipText(lt[28]);
	  bDefaults.getAccessibleContext().setAccessibleDescription(
	    lt[28]
	  );
	  // bOK 108
	  bOK = new JButton(ac[0]);
	  bOK.setToolTipText(lt[25]);
	  bOK.getAccessibleContext().setAccessibleDescription(
	    lt[25]
	  );
	  // bReset 110
	  bReset = new JButton(ac[2]);
	  bReset.setToolTipText(lt[27]);
	  bReset.getAccessibleContext().setAccessibleDescription(
	    lt[27]
	  );
	  // cbChooseLaf 13
	  cbChooseLaf = new JComboBox(lafNames);
	  cbChooseLaf.setToolTipText(lt[15]);
	  cbChooseLaf.getAccessibleContext().setAccessibleDescription(
	    lt[15]
	  );
	  // cbMinimumFontSize 16
	  cbMinimumFontSize = new JCheckBox(lt[4]);
	  cbMinimumFontSize.setToolTipText(lt[17]);
	  cbMinimumFontSize.getAccessibleContext().setAccessibleDescription(
	    lt[17]
	  );
	  // cbReplaceFont 18
	  cbReplaceFont = new JCheckBox(lt[6]);
	  cbReplaceFont.setToolTipText(lt[19]);
	  cbReplaceFont.getAccessibleContext().setAccessibleDescription(
	    lt[19]
	  );
	  // cbUseForAll 26
	  cbUseForAll = new JCheckBox(lt[14]);
	  cbUseForAll.setToolTipText(lt[24]);
	  cbUseForAll.getAccessibleContext().setAccessibleDescription(
	    lt[24]
	  );
	  cbUseForAll.setHorizontalAlignment(SwingConstants.CENTER);
	  // lBy 20
	  lBy = new JLabel(lt[9]);
	  // lChooseLaf 12
	  lChooseLaf = new JLabel(lt[1]);
	  // lComponentBorder 14
	  lComponentBorder = new JLabel(lt[2]);
	  // lFontsInUse 24
	  lFontsInUse = new JLabel(lt[12]);
	  // lFontsOrig 22
	  lFontsOrig = new JLabel(lt[10]);
	  // lRestartApplication 27
	  lRestartApplication = new JLabel(lt[13]);
	  lRestartApplication.setHorizontalAlignment(SwingConstants.CENTER);
	  // pButtons 28
	  pButtons = new JPanel();
	  {
	    pButtons.setLayout(new BoxLayout(pButtons, BoxLayout.X_AXIS));
	    pButtons.add(Box.createRigidArea(new Dimension(componentBorder, 0)));
	    pButtons.add(Box.createHorizontalGlue());
	    pButtons.add(Box.createRigidArea(new Dimension(componentBorder, 0)));
	    pButtons.add(bOK);
	    pButtons.add(Box.createRigidArea(new Dimension(componentBorder, 0)));
	    pButtons.add(bCancel);
	    pButtons.add(Box.createRigidArea(new Dimension(componentBorder, 0)));
	    pButtons.add(bReset);
	    pButtons.add(Box.createRigidArea(new Dimension(componentBorder, 0)));
	    pButtons.add(bDefaults);
	    pButtons.add(Box.createRigidArea(new Dimension(componentBorder, 0)));
	    pButtons.add(Box.createHorizontalGlue());
	    pButtons.add(Box.createRigidArea(new Dimension(componentBorder, 0)));
	  }
	  // tfComponentBorder 15
	  tfComponentBorder = new JTextField(3);
	  tfComponentBorder.setText(lt[3]);
	  tfComponentBorder.setToolTipText(lt[16]);
	  tfComponentBorder.getAccessibleContext().setAccessibleDescription(
	    lt[16]
	  );
	  // tfFontNew 21
	  tfFontNew = new JTextField(15);
	  tfFontNew.setText(lt[8]);
	  tfFontNew.setToolTipText(lt[21]);
	  tfFontNew.getAccessibleContext().setAccessibleDescription(
	    lt[21]
	  );
	  // tfFontOld 19
	  tfFontOld = new JTextField(15);
	  tfFontOld.setText(lt[7]);
	  tfFontOld.setToolTipText(lt[20]);
	  tfFontOld.getAccessibleContext().setAccessibleDescription(
	    lt[20]
	  );
	  // tfFontsInUse 25
	  tfFontsInUse = new JLabel(guic.getFontsUsed2());
	  tfFontsInUse.setToolTipText(lt[23]);
	  tfFontsInUse.getAccessibleContext().setAccessibleDescription(
	    lt[23]
	  );
	  // tfFontsOrig 23
	  tfFontsOrig = new JLabel(guic.getFontsUsed1());
	  tfFontsOrig.setToolTipText(lt[22]);
	  tfFontsOrig.getAccessibleContext().setAccessibleDescription(
	    lt[22]
	  );
	  // tfMinimumFontSize 17
	  tfMinimumFontSize = new JTextField(3);
	  tfMinimumFontSize.setText(lt[5]);
	  tfMinimumFontSize.setToolTipText(lt[18]);
	  tfMinimumFontSize.getAccessibleContext().setAccessibleDescription(
	    lt[18]
	  );
	  // MAIN 0
	  setTitle(lt[0]);
	  setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
	  {
	    Container cp = null;
	    cp = getContentPane();
	    GridBagLayout gbl = new GridBagLayout();
	    cp.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(componentBorder, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(componentBorder, false);
	    gbc = jLayoutGbc(
	      0, 18, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(componentBorder, false);
	    gbc = jLayoutGbc(
	      8, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(componentBorder, false);
	    gbc = jLayoutGbc(
	      8, 18, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(componentBorder, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(componentBorder, true);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(componentBorder, true);
	    gbc = jLayoutGbc(
	      6, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(componentBorder, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(componentBorder, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(componentBorder, true);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(componentBorder, true);
	    gbc = jLayoutGbc(
	      0, 8, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(componentBorder, true);
	    gbc = jLayoutGbc(
	      0, 10, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(componentBorder, true);
	    gbc = jLayoutGbc(
	      0, 12, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(componentBorder, true);
	    gbc = jLayoutGbc(
	      0, 14, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(componentBorder, true);
	    gbc = jLayoutGbc(
	      0, 16, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.EAST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lChooseLaf, gbc);
	    cp.add(lChooseLaf);
	    gbc = jLayoutGbc(
	      3, 1, 5, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbChooseLaf, gbc);
	    cp.add(cbChooseLaf);
	    gbc = jLayoutGbc(
	      1, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.EAST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lComponentBorder, gbc);
	    cp.add(lComponentBorder);
	    gbc = jLayoutGbc(
	      3, 3, 5, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(tfComponentBorder, gbc);
	    cp.add(tfComponentBorder);
	    gbc = jLayoutGbc(
	      1, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbMinimumFontSize, gbc);
	    cp.add(cbMinimumFontSize);
	    gbc = jLayoutGbc(
	      3, 5, 5, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(tfMinimumFontSize, gbc);
	    cp.add(tfMinimumFontSize);
	    gbc = jLayoutGbc(
	      1, 7, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbReplaceFont, gbc);
	    cp.add(cbReplaceFont);
	    gbc = jLayoutGbc(
	      3, 7, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(tfFontOld, gbc);
	    cp.add(tfFontOld);
	    gbc = jLayoutGbc(
	      5, 7, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lBy, gbc);
	    cp.add(lBy);
	    gbc = jLayoutGbc(
	      7, 7, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(tfFontNew, gbc);
	    cp.add(tfFontNew);
	    gbc = jLayoutGbc(
	      1, 9, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.EAST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lFontsOrig, gbc);
	    cp.add(lFontsOrig);
	    gbc = jLayoutGbc(
	      3, 9, 5, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(tfFontsOrig, gbc);
	    cp.add(tfFontsOrig);
	    gbc = jLayoutGbc(
	      1, 11, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.EAST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lFontsInUse, gbc);
	    cp.add(lFontsInUse);
	    gbc = jLayoutGbc(
	      3, 11, 5, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(tfFontsInUse, gbc);
	    cp.add(tfFontsInUse);
	    gbc = jLayoutGbc(
	      1, 13, 7, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbUseForAll, gbc);
	    cp.add(cbUseForAll);
	    gbc = jLayoutGbc(
	      1, 15, 7, 1,
	      GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lRestartApplication, gbc);
	    cp.add(lRestartApplication);
	    gbc = jLayoutGbc(
	      1, 17, 7, 1,
	      GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pButtons, gbc);
	    cp.add(pButtons);
	  }
	  jLayoutResetSizes();
	  jLayoutGetSize(bCancel);
	  jLayoutGetSize(bDefaults);
	  jLayoutGetSize(bOK);
	  jLayoutGetSize(bReset);
	  jLayoutSetSize(bCancel);
	  jLayoutSetSize(bDefaults);
	  jLayoutSetSize(bOK);
	  jLayoutSetSize(bReset);
	  bCancel.addActionListener(this);
	  bDefaults.addActionListener(this);
	  bOK.addActionListener(this);
	  bReset.addActionListener(this);
	  cbMinimumFontSize.addItemListener(this);
	  cbReplaceFont.addItemListener(this);
	  addWindowListener(this);
	}
// END OF JLAYOUT SECTION
// jlayout.setup.end

// jlayout.cleanup.begin
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	private void jLayoutCleanup()
	{
	  bCancel.removeActionListener(this);
	  bDefaults.removeActionListener(this);
	  bOK.removeActionListener(this);
	  bReset.removeActionListener(this);
	  cbMinimumFontSize.removeItemListener(this);
	  cbReplaceFont.removeItemListener(this);
	}
// END OF JLAYOUT SECTION
// jlayout.cleanup.end



  public GuiDialog(JFrame p, GuiController c) {
    super(p);
    guic = c;
    componentBorder = guic.getBorder();
    jLayoutSetup();
    setTitle(lt[0]);
    Font f = lRestartApplication.getFont();
    lRestartApplication.setFont(
      new Font(
        f.getName(),
	(f.getStyle() | Font.BOLD),
	f.getSize()
      )
    );
    pack();
    controllerToDialog();
  }


  public void cleanup() {
    jLayoutCleanup();
  }



  private int toRange(int v, int min, int max) {
    int back = v;
    if(back < min) { back = min; }
    if(back > max) { back = max; }
    return back;
  }


  private void checkEnabledComponents() {
    if(cbMinimumFontSize.isSelected()) {
      tfMinimumFontSize.setEnabled(true);
    } else {
      tfMinimumFontSize.setText(lt[11]);
      tfMinimumFontSize.setEnabled(false);
    }
    if(cbReplaceFont.isSelected()) {
      tfFontOld.setEnabled(true);
      tfFontNew.setEnabled(true);
    } else {
      tfFontOld.setText(lt[11]);
      tfFontNew.setText(lt[11]);
      tfFontOld.setEnabled(false);
      tfFontNew.setEnabled(false);
    }
  }


  public void controllerToDialog() {
    int i;
    cbChooseLaf.setSelectedIndex(
      toRange(guic.getLafIndex(), 0, (lafNames.length - 1))
    );
    i = guic.getMinimumFontSize();
    if(i > 0) {
      cbMinimumFontSize.setSelected(true);
      tfMinimumFontSize.setText((new Integer(i)).toString());
    } else {
      cbMinimumFontSize.setSelected(false);
    }
    tfComponentBorder.setText((new Integer(guic.getBorder())).toString());
    cbReplaceFont.setSelected(guic.getDoFontReplace());
    if(guic.getDoFontReplace()) {
      tfFontOld.setText(guic.getReplaceOldName());
      tfFontNew.setText(guic.getReplaceNewName());
    } else {
      tfFontOld.setText(lt[11]);
      tfFontNew.setText(lt[11]);
    }
    cbUseForAll.setSelected(false);
    checkEnabledComponents();
  }



  public void dialogToController() {
    try {
      Integer in = new Integer(tfComponentBorder.getText());
      int i = in.intValue();
      guic.setBorder(i);
    } catch (NumberFormatException e) {}
    guic.setLafIndex(cbChooseLaf.getSelectedIndex());
    if(cbMinimumFontSize.isSelected()) {
      try {
        Integer in = new Integer(tfMinimumFontSize.getText());
	int i = in.intValue();
	guic.setMinimumFontSize(i);
      } catch(NumberFormatException e) {}
    } else {
      guic.setMinimumFontSize(0);
    }
    guic.setDoFontReplace(cbReplaceFont.isSelected());
    if(cbReplaceFont.isSelected()) {
      guic.setReplaceOldName(tfFontOld.getText());
      guic.setReplaceNewName(tfFontNew.getText());
    } else {
      guic.setReplaceOldName(lt[11]);
      guic.setReplaceNewName(lt[11]);
    }
    if(cbUseForAll.isSelected()) {
      guic.writeProperties(true);
    }
  }



  /**
   * Handle action event.
   *
   * @param e
   * The action event to handle.
   */
  public void actionPerformed(ActionEvent e) {
    switch(StringTool.getArrayIndex(ac, e.getActionCommand())) {
      case 0: {
        dialogToController();
	setModal(false);
	setVisible(false);
      } break;
      case 1: {
        controllerToDialog();
	setModal(false);
	setVisible(false);
      } break;
      case 2: {
        controllerToDialog();
      } break;
      case 3: {
        cbChooseLaf.setSelectedIndex(0);
	tfComponentBorder.setText(lt[3]);
	cbMinimumFontSize.setSelected(false);
	cbReplaceFont.setSelected(false);
	cbUseForAll.setSelected(false);
	checkEnabledComponents();
	repaint();
      } break;
    }
  }

  /**
   * Handle item state changed event.
   *
   * @param e
   * The event to handle.
   */
  public void itemStateChanged(ItemEvent e) {
    checkEnabledComponents();
    repaint();
  }



  /**
   * Handle window closing event.
   *
   * @param e
   * The event to handle.
   */
  public void windowClosing(WindowEvent e) {
    setModal(false);
    setVisible(false);
    controllerToDialog();
  }



  /** Unused event handler */
  public void windowActivated(WindowEvent e) {}

  /** Unused event handler */
  public void windowClosed(WindowEvent e) {}

  /** Unused event handler */
  public void windowDeactivated(WindowEvent e) {}

  /** Unused event handler */
  public void windowDeiconified(WindowEvent e) {}

  /** Unused event handler */
  public void windowIconified(WindowEvent e) {}

  /** Unused event handler */
  public void windowOpened(WindowEvent e) {}


}


// vim: set ai sw=2 :



// project dklibsj
// @(#)GuiDialog.java 1.10 06/30/08

