/*
Copyright (c) 2009, Dirk Krause
All rights reserved.

Redistribution and use in source and binary forms,
with or without modification, are permitted provided
that the following conditions are met:

* Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.
* Redistributions in binary form must reproduce the above
  opyright notice, this list of conditions and the following
  disclaimer in the documentation and/or other materials
  provided with the distribution.
* Neither the name of the Dirk Krause nor the names of
  contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE.
*/

package bmepsgui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import java.awt.Color;

import javax.swing.JFrame;
import javax.swing.JDialog;
import javax.swing.JColorChooser;

import dirk_krause.tools.*;

// jlayout.import.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
import java.awt.CardLayout;
import java.awt.BorderLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Dimension;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowListener;
import java.awt.event.ItemListener;
import javax.swing.ButtonGroup;
import javax.swing.JComponent;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JRadioButton;
import javax.swing.JComboBox;
import javax.swing.WindowConstants;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;
import dirk_krause.tools.ColorShowArea;
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.import.end


/**
 *
 * @author krause
 */
public class BmepsOptions
        extends JDialog
        implements ActionListener, WindowListener, ItemListener
{
    /** Space between components. */
    private int border = 5;

    /** Parent window. */
    private BmepsWindow bmw = null;

    /** General tool. */
    private DkTool dkt = null;

    /** Gui controller. */
    private DkGuiTool dkgt = null;

    /** Strings used in the main window and here. */
    private String[] t = null;

    /** Bmeps controller. */
    private BmepsController bc = null;

    /** Flag to enable state changed listeners. */
    private boolean mustApplyCorrections = true;

    public static final String[] psVersions = { "1", "2", "3" };

    public static final String[] pdfVersions = { "1.2", "1.3", "1.4" };

    public static final String[] paperSizes = {
        "A3", "A4", "A5", "B4", "B5", "Letter", "Legal",
        "Tabloid", "Ledger", "Statement", "Executiv", "Folio",
        "Quarto", "10x14",
    };

    public static final String[] binaryToAscii = {
        "AsciiHex", "Ascii85"
    };

    public static final String[] sofno = {
      " 0 ", " 1 ", " 2 ", " 3 ", " 4 ", " 5 ", " 6 ", " 7 ", " 8 ",
      " 9 ", "10 ", "11 ", "12 ", "13 ", "14 ", "15 "
    };

    private String[] psImageMaskOptions = null;

    private String[] pdfFitOptions = null;

    private String[] builtinConfigurations = null;

    private String[] fileConfigurations = null;

    private String[] driverList = null;

    private String[] predNames = null;

    private CardLayout clFormatSpecificOptions = null;

    private boolean[] myBool = null;

    private int[] myInt = null;

    private String[] myStr = null;

// jlayout.variables.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	private int jLayoutSizeMinX = 0;
	private int jLayoutSizeMinY = 0;
	private int jLayoutSizePrefX = 0;
	private int jLayoutSizePrefY = 0;
	private int jLayoutSizeMaxX = 0;
	private int jLayoutSizeMaxY = 0;
	JButton bCancel = null;
	JButton bDefaults = null;
	JButton bOK = null;
	JButton bReload = null;
	JComboBox cbBuiltin = null;
	JComboBox cbChooseDriver = null;
	JCheckBox cbDraftMode = null;
	JCheckBox cbDsc = null;
	JCheckBox cbEncapsulated = null;
	JComboBox cbFromFile = null;
	JCheckBox cbMakeMode = null;
	JCheckBox cbPdfAlphaAttributes = null;
	JCheckBox cbPdfAlphaIngoreChunk = null;
	JCheckBox cbPdfAlphaMask = null;
	JComboBox cbPdfAlphaMaskHow = null;
	JCheckBox cbPdfAlphaMix = null;
	JCheckBox cbPdfAlphaTransfer = null;
	JComboBox cbPdfFit = null;
	JCheckBox cbPdfIgnoreJfif = null;
	JCheckBox cbPdfIntJpeg = null;
	JCheckBox cbPdfInterpol = null;
	JComboBox cbPdfPredictor = null;
	JComboBox cbPdfSizeFit = null;
	JCheckBox cbPdfSof00 = null;
	JCheckBox cbPdfSof01 = null;
	JCheckBox cbPdfSof02 = null;
	JCheckBox cbPdfSof03 = null;
	JCheckBox cbPdfSof04 = null;
	JCheckBox cbPdfSof05 = null;
	JCheckBox cbPdfSof06 = null;
	JCheckBox cbPdfSof07 = null;
	JCheckBox cbPdfSof08 = null;
	JCheckBox cbPdfSof09 = null;
	JCheckBox cbPdfSof10 = null;
	JCheckBox cbPdfSof11 = null;
	JCheckBox cbPdfSof12 = null;
	JCheckBox cbPdfSof13 = null;
	JCheckBox cbPdfSof14 = null;
	JCheckBox cbPdfSof15 = null;
	JComboBox cbPdfVersion = null;
	JComboBox cbPsBinToAscii = null;
	JCheckBox cbPsColored = null;
	JCheckBox cbPsDct = null;
	JCheckBox cbPsFlate = null;
	JCheckBox cbPsIgnoreBgChunk = null;
	JCheckBox cbPsIgnoreJfif = null;
	JCheckBox cbPsImageMask = null;
	JComboBox cbPsImageMaskOptions = null;
	JCheckBox cbPsIntJpeg = null;
	JCheckBox cbPsInterpolation = null;
	JCheckBox cbPsMix = null;
	JCheckBox cbPsMultipleData = null;
	JCheckBox cbPsOpDict = null;
	JCheckBox cbPsOpShowpage = null;
	JCheckBox cbPsOpVmreclaim = null;
	JCheckBox cbPsRunLength = null;
	JRadioButton cbPsSizeMedia = null;
	JRadioButton cbPsSizeOneOne = null;
	JComboBox cbPsSizePapers = null;
	JRadioButton cbPsSizeRes = null;
	JCheckBox cbPsSof00 = null;
	JCheckBox cbPsSof01 = null;
	JCheckBox cbPsSof02 = null;
	JCheckBox cbPsSof03 = null;
	JCheckBox cbPsSof04 = null;
	JCheckBox cbPsSof05 = null;
	JCheckBox cbPsSof06 = null;
	JCheckBox cbPsSof07 = null;
	JCheckBox cbPsSof08 = null;
	JCheckBox cbPsSof09 = null;
	JCheckBox cbPsSof10 = null;
	JCheckBox cbPsSof11 = null;
	JCheckBox cbPsSof12 = null;
	JCheckBox cbPsSof13 = null;
	JCheckBox cbPsSof14 = null;
	JCheckBox cbPsSof15 = null;
	JComboBox cbPsVersion = null;
	ColorShowArea csPdfAlphaMix = null;
	ColorShowArea csPs = null;
	JLabel lBbNoOptions = null;
	JLabel lChooseDriver = null;
	JLabel lPdfFit = null;
	JLabel lPdfPredictor = null;
	JLabel lPdfVersion = null;
	JLabel lPsBinToAscii = null;
	JLabel lPsVersion = null;
	JPanel pButtons = null;
	JPanel pDummy01 = null;
	JPanel pFormatBb = null;
	JPanel pFormatPdf = null;
	JTabbedPane pFormatPs = null;
	JPanel pFormatPsOuter = null;
	JPanel pFormatPsOuterOuter = null;
	JPanel pFormatSpecificOptions = null;
	JPanel pFullCustom = null;
	JPanel pMakeMode = null;
	JTabbedPane pOptions = null;
	JPanel pPdfAlpha = null;
	JPanel pPdfCompression = null;
	JPanel pPdfGeneral = null;
	JTabbedPane pPdfOptions = null;
	JPanel pPdfOuter = null;
	JPanel pPdfOuterOuter = null;
	JPanel pPdfSize = null;
	JPanel pPredefined = null;
	JPanel pPsAlpha = null;
	JPanel pPsCompression = null;
	JPanel pPsGeneral = null;
	JPanel pPsOperators = null;
	JPanel pPsSize = null;
	JPanel pa = null;
	JPanel paPdfSofs = null;
	JPanel paPsSofs = null;
	JRadioButton rbBuiltin = null;
	JRadioButton rbFromFile = null;
	JRadioButton rbPdfSizeChunk = null;
	JRadioButton rbPdfSizeFit = null;
	JRadioButton rbPdfSizeOneOne = null;
	ButtonGroup pdfSizeRadioButtonGroup = null;
	ButtonGroup psSizeRadioButtonGroup = null;
	ButtonGroup rbgConfigurations = null;
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.variables.end

// jlayout.setup.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	/**
	 * Reset the stored size informatio.
	 */
	private void jLayoutResetSizes()
	{
	  jLayoutSizeMinX = 0; jLayoutSizeMinY = 0;
	  jLayoutSizeMaxX = 0; jLayoutSizeMaxY = 0;
	  jLayoutSizePrefX = 0; jLayoutSizePrefY = 0;
	}
	private void jLayoutGetSize(JComponent c)
	{
	  Dimension d;
	  d = c.getMinimumSize();
	  if(d.width > jLayoutSizeMinX) { jLayoutSizeMinX = d.width; }
	  if(d.height > jLayoutSizeMinY) { jLayoutSizeMinY = d.height; }
	  d = c.getPreferredSize();
	  if(d.width > jLayoutSizePrefX) { jLayoutSizePrefX = d.width; }
	  if(d.height > jLayoutSizePrefY) { jLayoutSizePrefY = d.height; }
	  d = c.getMaximumSize();
	  if(d.width > jLayoutSizeMaxX) { jLayoutSizeMaxX = d.width; }
	  if(d.height > jLayoutSizeMaxY) { jLayoutSizeMaxY = d.height; }
	}
	/**
	 * Set a components size to a given minimum (save as other
	 * components).
	 *
	 * @param c
	 * The component to change.
	 */
	private void jLayoutSetSize(JComponent c)
	{
	  c.setMinimumSize(new Dimension(jLayoutSizeMinX, jLayoutSizeMinY));
	  c.setPreferredSize(new Dimension(jLayoutSizePrefX, jLayoutSizePrefY));
	  c.setMaximumSize(new Dimension(jLayoutSizeMaxX, jLayoutSizeMaxY));
	}
	/**
	 * Create GridBag constraints for a component.
	 *
	 * @param x
	 * The start grid column of the component.
	 *
	 * @param y
	 * The start grid line of the component.
	 *
	 * @param w
	 * The width of the component in grid columns.
	 *
	 * @param h
	 * The height of the component in grid lines.
	 *
	 * @param f
	 * The fill information (horizontal, vertical, both).
	 *
	 * @param wx
	 * The weight factor to grow the component horizontally
	 * when the container grows.
	 *
	 * @param wy
	 * The weight factor to grow the component vertically
	 * when the container grows.
	 */
	private GridBagConstraints jLayoutGbc(
	  int x, int y, int w, int h, int f, int a, double wx, double wy
	) {
	  GridBagConstraints back = new GridBagConstraints();
	  back.gridx = x;
	  back.gridy = y;
	  back.gridwidth = w;
	  back.gridheight = h;
	  back.fill = f;
	  back.anchor = a;
	  back.weightx = wx;
	  back.weighty = wy;
	  return back;
	}
	/**
	 * Create a dummy panel to ensure minimum distances.
	 *
	 * @param b
	 * The panels width and hight.
	 *
	 * @param rms
	 * A flag to indicate whether or not the panel must
	 * be set exactly to the given size (The panel can not grow).
	 */
	protected JPanel jLayoutCreateDistancePanel(int b, boolean rms)
	{
	  JPanel back = new JPanel();
	  Dimension d = new Dimension(b, b);
	  back.setMinimumSize(d);
	  back.setPreferredSize(d);
	  if(rms) {
	    back.setMaximumSize(d);
	  }
	  return back;
	}
	private void jLayoutSetup()
	{
	  // bCancel 562
	  bCancel = new JButton(t[28]);
	  bCancel.setToolTipText(t[29]);
	  bCancel.getAccessibleContext().setAccessibleDescription(
	    t[29]
	  );
	  // bDefaults 566
	  bDefaults = new JButton(t[32]);
	  bDefaults.setToolTipText(t[33]);
	  bDefaults.getAccessibleContext().setAccessibleDescription(
	    t[33]
	  );
	  // bOK 560
	  bOK = new JButton(t[26]);
	  bOK.setToolTipText(t[27]);
	  bOK.getAccessibleContext().setAccessibleDescription(
	    t[27]
	  );
	  // bReload 564
	  bReload = new JButton(t[30]);
	  bReload.setToolTipText(t[31]);
	  bReload.getAccessibleContext().setAccessibleDescription(
	    t[31]
	  );
	  // cbBuiltin 42
	  cbBuiltin = new JComboBox(builtinConfigurations);
	  // cbChooseDriver 72
	  cbChooseDriver = new JComboBox(driverList);
	  // cbDraftMode 25
	  cbDraftMode = new JCheckBox(t[45]);
	  cbDraftMode.setToolTipText(t[46]);
	  cbDraftMode.getAccessibleContext().setAccessibleDescription(
	    t[46]
	  );
	  // cbDsc 109
	  cbDsc = new JCheckBox(t[57]);
	  cbDsc.setToolTipText(t[63]);
	  cbDsc.getAccessibleContext().setAccessibleDescription(
	    t[63]
	  );
	  // cbEncapsulated 108
	  cbEncapsulated = new JCheckBox(t[56]);
	  cbEncapsulated.setToolTipText(t[62]);
	  cbEncapsulated.getAccessibleContext().setAccessibleDescription(
	    t[62]
	  );
	  // cbFromFile 44
	  cbFromFile = new JComboBox(fileConfigurations);
	  // cbMakeMode 24
	  cbMakeMode = new JCheckBox(t[42]);
	  cbMakeMode.setToolTipText(t[43]);
	  cbMakeMode.getAccessibleContext().setAccessibleDescription(
	    t[43]
	  );
	  // cbPdfAlphaAttributes 506
	  cbPdfAlphaAttributes = new JCheckBox(t[118]);
	  cbPdfAlphaAttributes.setToolTipText(t[119]);
	  cbPdfAlphaAttributes.getAccessibleContext().setAccessibleDescription(
	    t[119]
	  );
	  // cbPdfAlphaIngoreChunk 509
	  cbPdfAlphaIngoreChunk = new JCheckBox(t[68]);
	  cbPdfAlphaIngoreChunk.setToolTipText(t[74]);
	  cbPdfAlphaIngoreChunk.getAccessibleContext().setAccessibleDescription(
	    t[74]
	  );
	  // cbPdfAlphaMask 510
	  cbPdfAlphaMask = new JCheckBox(t[69]);
	  cbPdfAlphaMask.setToolTipText(t[75]);
	  cbPdfAlphaMask.getAccessibleContext().setAccessibleDescription(
	    t[75]
	  );
	  // cbPdfAlphaMaskHow 511
	  cbPdfAlphaMaskHow = new JComboBox(psImageMaskOptions);
	  // cbPdfAlphaMix 507
	  cbPdfAlphaMix = new JCheckBox(t[67]);
	  cbPdfAlphaMix.setToolTipText(t[72]);
	  cbPdfAlphaMix.getAccessibleContext().setAccessibleDescription(
	    t[72]
	  );
	  // cbPdfAlphaTransfer 504
	  cbPdfAlphaTransfer = new JCheckBox(t[116]);
	  cbPdfAlphaTransfer.setToolTipText(t[117]);
	  cbPdfAlphaTransfer.getAccessibleContext().setAccessibleDescription(
	    t[117]
	  );
	  // cbPdfFit 357
	  cbPdfFit = new JComboBox(pdfFitOptions);
	  // cbPdfIgnoreJfif 416
	  cbPdfIgnoreJfif = new JCheckBox(t[99]);
	  cbPdfIgnoreJfif.setToolTipText(t[100]);
	  cbPdfIgnoreJfif.getAccessibleContext().setAccessibleDescription(
	    t[100]
	  );
	  // cbPdfIntJpeg 359
	  cbPdfIntJpeg = new JCheckBox(t[60]);
	  cbPdfIntJpeg.setToolTipText(t[66]);
	  cbPdfIntJpeg.getAccessibleContext().setAccessibleDescription(
	    t[66]
	  );
	  // cbPdfInterpol 358
	  cbPdfInterpol = new JCheckBox(t[59]);
	  cbPdfInterpol.setToolTipText(t[65]);
	  cbPdfInterpol.getAccessibleContext().setAccessibleDescription(
	    t[65]
	  );
	  // cbPdfPredictor 419
	  cbPdfPredictor = new JComboBox(predNames);
	  cbPdfPredictor.setToolTipText(t[142]);
	  cbPdfPredictor.getAccessibleContext().setAccessibleDescription(
	    t[142]
	  );
	  // cbPdfSizeFit 391
	  cbPdfSizeFit = new JComboBox(paperSizes);
	  // cbPdfSof00 429
	  cbPdfSof00 = new JCheckBox(sofno[0]);
	  cbPdfSof00.setToolTipText(t[102]);
	  cbPdfSof00.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPdfSof01 430
	  cbPdfSof01 = new JCheckBox(sofno[1]);
	  cbPdfSof01.setToolTipText(t[102]);
	  cbPdfSof01.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPdfSof02 431
	  cbPdfSof02 = new JCheckBox(sofno[2]);
	  cbPdfSof02.setToolTipText(t[102]);
	  cbPdfSof02.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPdfSof03 432
	  cbPdfSof03 = new JCheckBox(sofno[3]);
	  cbPdfSof03.setToolTipText(t[102]);
	  cbPdfSof03.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPdfSof04 433
	  cbPdfSof04 = new JCheckBox(sofno[4]);
	  cbPdfSof04.setToolTipText(t[102]);
	  cbPdfSof04.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPdfSof05 434
	  cbPdfSof05 = new JCheckBox(sofno[5]);
	  cbPdfSof05.setToolTipText(t[102]);
	  cbPdfSof05.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPdfSof06 435
	  cbPdfSof06 = new JCheckBox(sofno[6]);
	  cbPdfSof06.setToolTipText(t[102]);
	  cbPdfSof06.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPdfSof07 436
	  cbPdfSof07 = new JCheckBox(sofno[7]);
	  cbPdfSof07.setToolTipText(t[102]);
	  cbPdfSof07.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPdfSof08 437
	  cbPdfSof08 = new JCheckBox(sofno[8]);
	  cbPdfSof08.setToolTipText(t[102]);
	  cbPdfSof08.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPdfSof09 438
	  cbPdfSof09 = new JCheckBox(sofno[9]);
	  cbPdfSof09.setToolTipText(t[102]);
	  cbPdfSof09.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPdfSof10 439
	  cbPdfSof10 = new JCheckBox(sofno[10]);
	  cbPdfSof10.setToolTipText(t[102]);
	  cbPdfSof10.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPdfSof11 440
	  cbPdfSof11 = new JCheckBox(sofno[11]);
	  cbPdfSof11.setToolTipText(t[102]);
	  cbPdfSof11.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPdfSof12 441
	  cbPdfSof12 = new JCheckBox(sofno[12]);
	  cbPdfSof12.setToolTipText(t[102]);
	  cbPdfSof12.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPdfSof13 442
	  cbPdfSof13 = new JCheckBox(sofno[13]);
	  cbPdfSof13.setToolTipText(t[102]);
	  cbPdfSof13.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPdfSof14 443
	  cbPdfSof14 = new JCheckBox(sofno[14]);
	  cbPdfSof14.setToolTipText(t[102]);
	  cbPdfSof14.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPdfSof15 444
	  cbPdfSof15 = new JCheckBox(sofno[15]);
	  cbPdfSof15.setToolTipText(t[102]);
	  cbPdfSof15.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPdfVersion 355
	  cbPdfVersion = new JComboBox(pdfVersions);
	  cbPdfVersion.setActionCommand(t[121]);
	  // cbPsBinToAscii 226
	  cbPsBinToAscii = new JComboBox(binaryToAscii);
	  cbPsBinToAscii.setToolTipText(t[90]);
	  cbPsBinToAscii.getAccessibleContext().setAccessibleDescription(
	    t[90]
	  );
	  // cbPsColored 110
	  cbPsColored = new JCheckBox(t[58]);
	  cbPsColored.setToolTipText(t[64]);
	  cbPsColored.getAccessibleContext().setAccessibleDescription(
	    t[64]
	  );
	  // cbPsDct 230
	  cbPsDct = new JCheckBox(t[97]);
	  cbPsDct.setToolTipText(t[98]);
	  cbPsDct.getAccessibleContext().setAccessibleDescription(
	    t[98]
	  );
	  // cbPsFlate 229
	  cbPsFlate = new JCheckBox(t[95]);
	  cbPsFlate.setToolTipText(t[96]);
	  cbPsFlate.getAccessibleContext().setAccessibleDescription(
	    t[96]
	  );
	  // cbPsIgnoreBgChunk 148
	  cbPsIgnoreBgChunk = new JCheckBox(t[68]);
	  cbPsIgnoreBgChunk.setToolTipText(t[74]);
	  cbPsIgnoreBgChunk.getAccessibleContext().setAccessibleDescription(
	    t[74]
	  );
	  // cbPsIgnoreJfif 231
	  cbPsIgnoreJfif = new JCheckBox(t[99]);
	  cbPsIgnoreJfif.setToolTipText(t[100]);
	  cbPsIgnoreJfif.getAccessibleContext().setAccessibleDescription(
	    t[100]
	  );
	  // cbPsImageMask 149
	  cbPsImageMask = new JCheckBox(t[69]);
	  cbPsImageMask.setToolTipText(t[75]);
	  cbPsImageMask.getAccessibleContext().setAccessibleDescription(
	    t[75]
	  );
	  // cbPsImageMaskOptions 150
	  cbPsImageMaskOptions = new JComboBox(psImageMaskOptions);
	  // cbPsIntJpeg 112
	  cbPsIntJpeg = new JCheckBox(t[60]);
	  cbPsIntJpeg.setToolTipText(t[66]);
	  cbPsIntJpeg.getAccessibleContext().setAccessibleDescription(
	    t[66]
	  );
	  // cbPsInterpolation 111
	  cbPsInterpolation = new JCheckBox(t[59]);
	  cbPsInterpolation.setToolTipText(t[65]);
	  cbPsInterpolation.getAccessibleContext().setAccessibleDescription(
	    t[65]
	  );
	  // cbPsMix 146
	  cbPsMix = new JCheckBox(t[67]);
	  cbPsMix.setToolTipText(t[72]);
	  cbPsMix.getAccessibleContext().setAccessibleDescription(
	    t[72]
	  );
	  // cbPsMultipleData 228
	  cbPsMultipleData = new JCheckBox(t[93]);
	  cbPsMultipleData.setToolTipText(t[94]);
	  cbPsMultipleData.getAccessibleContext().setAccessibleDescription(
	    t[94]
	  );
	  // cbPsOpDict 205
	  cbPsOpDict = new JCheckBox(t[83]);
	  cbPsOpDict.setToolTipText(t[86]);
	  cbPsOpDict.getAccessibleContext().setAccessibleDescription(
	    t[86]
	  );
	  // cbPsOpShowpage 207
	  cbPsOpShowpage = new JCheckBox(t[85]);
	  cbPsOpShowpage.setToolTipText(t[88]);
	  cbPsOpShowpage.getAccessibleContext().setAccessibleDescription(
	    t[88]
	  );
	  // cbPsOpVmreclaim 206
	  cbPsOpVmreclaim = new JCheckBox(t[84]);
	  cbPsOpVmreclaim.setToolTipText(t[87]);
	  cbPsOpVmreclaim.getAccessibleContext().setAccessibleDescription(
	    t[87]
	  );
	  // cbPsRunLength 227
	  cbPsRunLength = new JCheckBox(t[91]);
	  cbPsRunLength.setToolTipText(t[92]);
	  cbPsRunLength.getAccessibleContext().setAccessibleDescription(
	    t[92]
	  );
	  // cbPsSizeMedia 178
	  cbPsSizeMedia = new JRadioButton(t[78]);
	  cbPsSizeMedia.setToolTipText(t[81]);
	  cbPsSizeMedia.getAccessibleContext().setAccessibleDescription(
	    t[81]
	  );
	  // cbPsSizeOneOne 176
	  cbPsSizeOneOne = new JRadioButton(t[76]);
	  cbPsSizeOneOne.setToolTipText(t[79]);
	  cbPsSizeOneOne.getAccessibleContext().setAccessibleDescription(
	    t[79]
	  );
	  // cbPsSizePapers 179
	  cbPsSizePapers = new JComboBox(paperSizes);
	  cbPsSizePapers.setToolTipText(t[82]);
	  cbPsSizePapers.getAccessibleContext().setAccessibleDescription(
	    t[82]
	  );
	  // cbPsSizeRes 177
	  cbPsSizeRes = new JRadioButton(t[77]);
	  cbPsSizeRes.setToolTipText(t[80]);
	  cbPsSizeRes.getAccessibleContext().setAccessibleDescription(
	    t[80]
	  );
	  // cbPsSof00 267
	  cbPsSof00 = new JCheckBox(sofno[0]);
	  cbPsSof00.setToolTipText(t[102]);
	  cbPsSof00.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPsSof01 268
	  cbPsSof01 = new JCheckBox(sofno[1]);
	  cbPsSof01.setToolTipText(t[102]);
	  cbPsSof01.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPsSof02 269
	  cbPsSof02 = new JCheckBox(sofno[2]);
	  cbPsSof02.setToolTipText(t[102]);
	  cbPsSof02.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPsSof03 270
	  cbPsSof03 = new JCheckBox(sofno[3]);
	  cbPsSof03.setToolTipText(t[102]);
	  cbPsSof03.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPsSof04 271
	  cbPsSof04 = new JCheckBox(sofno[4]);
	  cbPsSof04.setToolTipText(t[102]);
	  cbPsSof04.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPsSof05 272
	  cbPsSof05 = new JCheckBox(sofno[5]);
	  cbPsSof05.setToolTipText(t[102]);
	  cbPsSof05.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPsSof06 273
	  cbPsSof06 = new JCheckBox(sofno[6]);
	  cbPsSof06.setToolTipText(t[102]);
	  cbPsSof06.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPsSof07 274
	  cbPsSof07 = new JCheckBox(sofno[7]);
	  cbPsSof07.setToolTipText(t[102]);
	  cbPsSof07.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPsSof08 275
	  cbPsSof08 = new JCheckBox(sofno[8]);
	  cbPsSof08.setToolTipText(t[102]);
	  cbPsSof08.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPsSof09 276
	  cbPsSof09 = new JCheckBox(sofno[9]);
	  cbPsSof09.setToolTipText(t[102]);
	  cbPsSof09.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPsSof10 277
	  cbPsSof10 = new JCheckBox(sofno[10]);
	  cbPsSof10.setToolTipText(t[102]);
	  cbPsSof10.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPsSof11 278
	  cbPsSof11 = new JCheckBox(sofno[11]);
	  cbPsSof11.setToolTipText(t[102]);
	  cbPsSof11.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPsSof12 279
	  cbPsSof12 = new JCheckBox(sofno[12]);
	  cbPsSof12.setToolTipText(t[102]);
	  cbPsSof12.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPsSof13 280
	  cbPsSof13 = new JCheckBox(sofno[13]);
	  cbPsSof13.setToolTipText(t[102]);
	  cbPsSof13.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPsSof14 281
	  cbPsSof14 = new JCheckBox(sofno[14]);
	  cbPsSof14.setToolTipText(t[102]);
	  cbPsSof14.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPsSof15 282
	  cbPsSof15 = new JCheckBox(sofno[15]);
	  cbPsSof15.setToolTipText(t[102]);
	  cbPsSof15.getAccessibleContext().setAccessibleDescription(
	    t[102]
	  );
	  // cbPsVersion 107
	  cbPsVersion = new JComboBox(psVersions);
	  cbPsVersion.setActionCommand(t[120]);
	  cbPsVersion.setToolTipText(t[61]);
	  cbPsVersion.getAccessibleContext().setAccessibleDescription(
	    t[61]
	  );
	  // csPdfAlphaMix 508
	  csPdfAlphaMix = new ColorShowArea();
	  csPdfAlphaMix.setActionCommand(t[124]);
	  csPdfAlphaMix.setToolTipText(t[73]);
	  csPdfAlphaMix.getAccessibleContext().setAccessibleDescription(
	    t[73]
	  );
	  // csPs 147
	  csPs = new ColorShowArea();
	  csPs.setActionCommand(t[123]);
	  csPs.setToolTipText(t[73]);
	  csPs.getAccessibleContext().setAccessibleDescription(
	    t[73]
	  );
	  // lBbNoOptions 550
	  lBbNoOptions = new JLabel(t[104]);
	  // lChooseDriver 71
	  lChooseDriver = new JLabel(t[122]);
	  // lPdfFit 356
	  lPdfFit = new JLabel(t[111]);
	  // lPdfPredictor 418
	  lPdfPredictor = new JLabel(t[135]);
	  // lPdfVersion 354
	  lPdfVersion = new JLabel(t[110]);
	  // lPsBinToAscii 225
	  lPsBinToAscii = new JLabel(t[89]);
	  // lPsVersion 106
	  lPsVersion = new JLabel(t[55]);
	  // pButtons 18
	  pButtons = new JPanel();
	  {
	    pButtons.setLayout(new BoxLayout(pButtons, BoxLayout.LINE_AXIS));
	    pButtons.add(Box.createRigidArea(new Dimension(border, 0)));
	    pButtons.add(Box.createHorizontalGlue());
	    pButtons.add(Box.createRigidArea(new Dimension(border, 0)));
	    pButtons.add(bOK);
	    pButtons.add(Box.createRigidArea(new Dimension(border, 0)));
	    pButtons.add(Box.createHorizontalGlue());
	    pButtons.add(Box.createRigidArea(new Dimension(border, 0)));
	    pButtons.add(bCancel);
	    pButtons.add(Box.createRigidArea(new Dimension(border, 0)));
	    pButtons.add(Box.createHorizontalGlue());
	    pButtons.add(Box.createRigidArea(new Dimension(border, 0)));
	    pButtons.add(bReload);
	    pButtons.add(Box.createRigidArea(new Dimension(border, 0)));
	    pButtons.add(Box.createHorizontalGlue());
	    pButtons.add(Box.createRigidArea(new Dimension(border, 0)));
	    pButtons.add(bDefaults);
	    pButtons.add(Box.createRigidArea(new Dimension(border, 0)));
	    pButtons.add(Box.createHorizontalGlue());
	    pButtons.add(Box.createRigidArea(new Dimension(border, 0)));
	  }
	  // pDummy01 505
	  pDummy01 = new JPanel();
	  pDummy01.setMinimumSize(new Dimension(10, 1));
	  pDummy01.setPreferredSize(new Dimension(15, 1));
	  // pFormatBb 86
	  pFormatBb = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pFormatBb.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pFormatBb.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pFormatBb.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pFormatBb.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      2, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pFormatBb.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lBbNoOptions, gbc);
	    pFormatBb.add(lBbNoOptions);
	  }
	  // pMakeMode 16
	  pMakeMode = new JPanel();
	  pMakeMode.setBorder(
	    BorderFactory.createTitledBorder(t[44])
	  );
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pMakeMode.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pMakeMode.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pMakeMode.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pMakeMode.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      2, 4, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pMakeMode.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pMakeMode.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbMakeMode, gbc);
	    pMakeMode.add(cbMakeMode);
	    gbc = jLayoutGbc(
	      1, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbDraftMode, gbc);
	    pMakeMode.add(cbDraftMode);
	  }
	  // pPdfAlpha 350
	  pPdfAlpha = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pPdfAlpha.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfAlpha.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 8, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfAlpha.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      8, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfAlpha.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      8, 8, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfAlpha.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfAlpha.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfAlpha.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      6, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfAlpha.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfAlpha.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfAlpha.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfAlpha.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 7, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfAlphaTransfer, gbc);
	    pPdfAlpha.add(cbPdfAlphaTransfer);
	    gbc = jLayoutGbc(
	      1, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pDummy01, gbc);
	    pPdfAlpha.add(pDummy01);
	    gbc = jLayoutGbc(
	      3, 3, 5, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfAlphaAttributes, gbc);
	    pPdfAlpha.add(cbPdfAlphaAttributes);
	    gbc = jLayoutGbc(
	      1, 5, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfAlphaMix, gbc);
	    pPdfAlpha.add(cbPdfAlphaMix);
	    gbc = jLayoutGbc(
	      5, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(csPdfAlphaMix, gbc);
	    pPdfAlpha.add(csPdfAlphaMix);
	    gbc = jLayoutGbc(
	      7, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfAlphaIngoreChunk, gbc);
	    pPdfAlpha.add(cbPdfAlphaIngoreChunk);
	    gbc = jLayoutGbc(
	      1, 7, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfAlphaMask, gbc);
	    pPdfAlpha.add(cbPdfAlphaMask);
	    gbc = jLayoutGbc(
	      5, 7, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfAlphaMaskHow, gbc);
	    pPdfAlpha.add(cbPdfAlphaMaskHow);
	  }
	  // pPdfGeneral 347
	  pPdfGeneral = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pPdfGeneral.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      7, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      7, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfGeneral.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lPdfVersion, gbc);
	    pPdfGeneral.add(lPdfVersion);
	    gbc = jLayoutGbc(
	      3, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfVersion, gbc);
	    pPdfGeneral.add(cbPdfVersion);
	    gbc = jLayoutGbc(
	      1, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lPdfFit, gbc);
	    pPdfGeneral.add(lPdfFit);
	    gbc = jLayoutGbc(
	      3, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfFit, gbc);
	    pPdfGeneral.add(cbPdfFit);
	    gbc = jLayoutGbc(
	      1, 5, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfInterpol, gbc);
	    pPdfGeneral.add(cbPdfInterpol);
	    gbc = jLayoutGbc(
	      5, 5, 2, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfIntJpeg, gbc);
	    pPdfGeneral.add(cbPdfIntJpeg);
	  }
	  // pPsAlpha 101
	  pPsAlpha = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pPsAlpha.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsAlpha.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsAlpha.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsAlpha.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      4, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsAlpha.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsAlpha.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsAlpha.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsAlpha.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsMix, gbc);
	    pPsAlpha.add(cbPsMix);
	    gbc = jLayoutGbc(
	      3, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(csPs, gbc);
	    pPsAlpha.add(csPs);
	    gbc = jLayoutGbc(
	      1, 3, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsIgnoreBgChunk, gbc);
	    pPsAlpha.add(cbPsIgnoreBgChunk);
	    gbc = jLayoutGbc(
	      1, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsImageMask, gbc);
	    pPsAlpha.add(cbPsImageMask);
	    gbc = jLayoutGbc(
	      3, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsImageMaskOptions, gbc);
	    pPsAlpha.add(cbPsImageMaskOptions);
	  }
	  // pPsGeneral 98
	  pPsGeneral = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pPsGeneral.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 10, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      6, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      6, 10, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 8, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsGeneral.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lPsVersion, gbc);
	    pPsGeneral.add(lPsVersion);
	    gbc = jLayoutGbc(
	      3, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsVersion, gbc);
	    pPsGeneral.add(cbPsVersion);
	    gbc = jLayoutGbc(
	      1, 3, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbEncapsulated, gbc);
	    pPsGeneral.add(cbEncapsulated);
	    gbc = jLayoutGbc(
	      1, 5, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbDsc, gbc);
	    pPsGeneral.add(cbDsc);
	    gbc = jLayoutGbc(
	      1, 7, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsColored, gbc);
	    pPsGeneral.add(cbPsColored);
	    gbc = jLayoutGbc(
	      1, 9, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsInterpolation, gbc);
	    pPsGeneral.add(cbPsInterpolation);
	    gbc = jLayoutGbc(
	      5, 9, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsIntJpeg, gbc);
	    pPsGeneral.add(cbPsIntJpeg);
	  }
	  // pPsOperators 102
	  pPsOperators = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pPsOperators.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsOperators.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsOperators.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsOperators.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      2, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsOperators.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsOperators.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsOperators.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsOpDict, gbc);
	    pPsOperators.add(cbPsOpDict);
	    gbc = jLayoutGbc(
	      1, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsOpVmreclaim, gbc);
	    pPsOperators.add(cbPsOpVmreclaim);
	    gbc = jLayoutGbc(
	      1, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsOpShowpage, gbc);
	    pPsOperators.add(cbPsOpShowpage);
	  }
	  // pPsSize 99
	  pPsSize = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pPsSize.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsSize.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsSize.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsSize.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      4, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsSize.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsSize.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsSize.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsSize.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSizeOneOne, gbc);
	    pPsSize.add(cbPsSizeOneOne);
	    gbc = jLayoutGbc(
	      1, 3, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSizeRes, gbc);
	    pPsSize.add(cbPsSizeRes);
	    gbc = jLayoutGbc(
	      1, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSizeMedia, gbc);
	    pPsSize.add(cbPsSizeMedia);
	    gbc = jLayoutGbc(
	      3, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSizePapers, gbc);
	    pPsSize.add(cbPsSizePapers);
	  }
	  // paPdfSofs 417
	  paPdfSofs = new JPanel();
	  paPdfSofs.setBorder(
	    BorderFactory.createTitledBorder(t[101])
	  );
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    paPdfSofs.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      32, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      32, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      6, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      8, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      10, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      12, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      14, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      16, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      18, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      20, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      22, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      24, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      26, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      28, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      30, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPdfSofs.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfSof00, gbc);
	    paPdfSofs.add(cbPdfSof00);
	    gbc = jLayoutGbc(
	      3, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfSof01, gbc);
	    paPdfSofs.add(cbPdfSof01);
	    gbc = jLayoutGbc(
	      5, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfSof02, gbc);
	    paPdfSofs.add(cbPdfSof02);
	    gbc = jLayoutGbc(
	      7, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfSof03, gbc);
	    paPdfSofs.add(cbPdfSof03);
	    gbc = jLayoutGbc(
	      9, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfSof04, gbc);
	    paPdfSofs.add(cbPdfSof04);
	    gbc = jLayoutGbc(
	      11, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfSof05, gbc);
	    paPdfSofs.add(cbPdfSof05);
	    gbc = jLayoutGbc(
	      13, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfSof06, gbc);
	    paPdfSofs.add(cbPdfSof06);
	    gbc = jLayoutGbc(
	      15, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfSof07, gbc);
	    paPdfSofs.add(cbPdfSof07);
	    gbc = jLayoutGbc(
	      17, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfSof08, gbc);
	    paPdfSofs.add(cbPdfSof08);
	    gbc = jLayoutGbc(
	      19, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfSof09, gbc);
	    paPdfSofs.add(cbPdfSof09);
	    gbc = jLayoutGbc(
	      21, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfSof10, gbc);
	    paPdfSofs.add(cbPdfSof10);
	    gbc = jLayoutGbc(
	      23, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfSof11, gbc);
	    paPdfSofs.add(cbPdfSof11);
	    gbc = jLayoutGbc(
	      25, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfSof12, gbc);
	    paPdfSofs.add(cbPdfSof12);
	    gbc = jLayoutGbc(
	      27, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfSof13, gbc);
	    paPdfSofs.add(cbPdfSof13);
	    gbc = jLayoutGbc(
	      29, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfSof14, gbc);
	    paPdfSofs.add(cbPdfSof14);
	    gbc = jLayoutGbc(
	      31, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfSof15, gbc);
	    paPdfSofs.add(cbPdfSof15);
	  }
	  // paPsSofs 232
	  paPsSofs = new JPanel();
	  paPsSofs.setBorder(
	    BorderFactory.createTitledBorder(t[101])
	  );
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    paPsSofs.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      32, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      32, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      6, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      8, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      10, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      12, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      14, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      16, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      18, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      20, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      22, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      24, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      26, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      28, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      30, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paPsSofs.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSof00, gbc);
	    paPsSofs.add(cbPsSof00);
	    gbc = jLayoutGbc(
	      3, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSof01, gbc);
	    paPsSofs.add(cbPsSof01);
	    gbc = jLayoutGbc(
	      5, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSof02, gbc);
	    paPsSofs.add(cbPsSof02);
	    gbc = jLayoutGbc(
	      7, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSof03, gbc);
	    paPsSofs.add(cbPsSof03);
	    gbc = jLayoutGbc(
	      9, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSof04, gbc);
	    paPsSofs.add(cbPsSof04);
	    gbc = jLayoutGbc(
	      11, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSof05, gbc);
	    paPsSofs.add(cbPsSof05);
	    gbc = jLayoutGbc(
	      13, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSof06, gbc);
	    paPsSofs.add(cbPsSof06);
	    gbc = jLayoutGbc(
	      15, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSof07, gbc);
	    paPsSofs.add(cbPsSof07);
	    gbc = jLayoutGbc(
	      17, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSof08, gbc);
	    paPsSofs.add(cbPsSof08);
	    gbc = jLayoutGbc(
	      19, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSof09, gbc);
	    paPsSofs.add(cbPsSof09);
	    gbc = jLayoutGbc(
	      21, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSof10, gbc);
	    paPsSofs.add(cbPsSof10);
	    gbc = jLayoutGbc(
	      23, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSof11, gbc);
	    paPsSofs.add(cbPsSof11);
	    gbc = jLayoutGbc(
	      25, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSof12, gbc);
	    paPsSofs.add(cbPsSof12);
	    gbc = jLayoutGbc(
	      27, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSof13, gbc);
	    paPsSofs.add(cbPsSof13);
	    gbc = jLayoutGbc(
	      29, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSof14, gbc);
	    paPsSofs.add(cbPsSof14);
	    gbc = jLayoutGbc(
	      31, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsSof15, gbc);
	    paPsSofs.add(cbPsSof15);
	  }
	  // rbBuiltin 41
	  rbBuiltin = new JRadioButton(t[39]);
	  rbBuiltin.setText(t[36]);
	  rbBuiltin.setActionCommand(t[39]);
	  rbBuiltin.setToolTipText(t[38]);
	  rbBuiltin.getAccessibleContext().setAccessibleDescription(
	    t[38]
	  );
	  // rbFromFile 43
	  rbFromFile = new JRadioButton(t[41]);
	  rbFromFile.setText(t[37]);
	  rbFromFile.setActionCommand(t[41]);
	  rbFromFile.setToolTipText(t[40]);
	  rbFromFile.getAccessibleContext().setAccessibleDescription(
	    t[40]
	  );
	  // rbPdfSizeChunk 389
	  rbPdfSizeChunk = new JRadioButton(t[77]);
	  rbPdfSizeChunk.setToolTipText(t[80]);
	  rbPdfSizeChunk.getAccessibleContext().setAccessibleDescription(
	    t[80]
	  );
	  // rbPdfSizeFit 390
	  rbPdfSizeFit = new JRadioButton(t[78]);
	  rbPdfSizeFit.setToolTipText(t[81]);
	  rbPdfSizeFit.getAccessibleContext().setAccessibleDescription(
	    t[81]
	  );
	  // rbPdfSizeOneOne 388
	  rbPdfSizeOneOne = new JRadioButton(t[76]);
	  rbPdfSizeOneOne.setToolTipText(t[79]);
	  rbPdfSizeOneOne.getAccessibleContext().setAccessibleDescription(
	    t[79]
	  );
	  // pPdfCompression 349
	  pPdfCompression = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pPdfCompression.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfCompression.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfCompression.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      5, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfCompression.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      5, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfCompression.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfCompression.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfCompression.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfCompression.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfIgnoreJfif, gbc);
	    pPdfCompression.add(cbPdfIgnoreJfif);
	    gbc = jLayoutGbc(
	      1, 3, 4, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(paPdfSofs, gbc);
	    pPdfCompression.add(paPdfSofs);
	    gbc = jLayoutGbc(
	      1, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lPdfPredictor, gbc);
	    pPdfCompression.add(lPdfPredictor);
	    gbc = jLayoutGbc(
	      3, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfPredictor, gbc);
	    pPdfCompression.add(cbPdfPredictor);
	  }
	  // pPdfSize 348
	  pPdfSize = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pPdfSize.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfSize.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfSize.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfSize.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      4, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfSize.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfSize.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfSize.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfSize.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(rbPdfSizeOneOne, gbc);
	    pPdfSize.add(rbPdfSizeOneOne);
	    gbc = jLayoutGbc(
	      1, 3, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(rbPdfSizeChunk, gbc);
	    pPdfSize.add(rbPdfSizeChunk);
	    gbc = jLayoutGbc(
	      1, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(rbPdfSizeFit, gbc);
	    pPdfSize.add(rbPdfSizeFit);
	    gbc = jLayoutGbc(
	      3, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPdfSizeFit, gbc);
	    pPdfSize.add(cbPdfSizeFit);
	  }
	  // pPredefined 36
	  pPredefined = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pPredefined.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPredefined.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPredefined.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPredefined.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      4, 4, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPredefined.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPredefined.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPredefined.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(rbBuiltin, gbc);
	    pPredefined.add(rbBuiltin);
	    gbc = jLayoutGbc(
	      3, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbBuiltin, gbc);
	    pPredefined.add(cbBuiltin);
	    gbc = jLayoutGbc(
	      1, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(rbFromFile, gbc);
	    pPredefined.add(rbFromFile);
	    gbc = jLayoutGbc(
	      3, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbFromFile, gbc);
	    pPredefined.add(cbFromFile);
	  }
	  // pPsCompression 100
	  pPsCompression = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pPsCompression.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsCompression.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 10, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsCompression.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsCompression.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      4, 10, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsCompression.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsCompression.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsCompression.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsCompression.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsCompression.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 8, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pPsCompression.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lPsBinToAscii, gbc);
	    pPsCompression.add(lPsBinToAscii);
	    gbc = jLayoutGbc(
	      3, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsBinToAscii, gbc);
	    pPsCompression.add(cbPsBinToAscii);
	    gbc = jLayoutGbc(
	      1, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsRunLength, gbc);
	    pPsCompression.add(cbPsRunLength);
	    gbc = jLayoutGbc(
	      3, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsMultipleData, gbc);
	    pPsCompression.add(cbPsMultipleData);
	    gbc = jLayoutGbc(
	      1, 5, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsFlate, gbc);
	    pPsCompression.add(cbPsFlate);
	    gbc = jLayoutGbc(
	      1, 7, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsDct, gbc);
	    pPsCompression.add(cbPsDct);
	    gbc = jLayoutGbc(
	      3, 7, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbPsIgnoreJfif, gbc);
	    pPsCompression.add(cbPsIgnoreJfif);
	    gbc = jLayoutGbc(
	      1, 9, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(paPsSofs, gbc);
	    pPsCompression.add(paPsSofs);
	  }
	  // pFormatPs 95
	  pFormatPs = new JTabbedPane();
	  {
	    pFormatPs.add(pPsGeneral, t[50]);
	    pFormatPs.add(pPsSize, t[52]);
	    pFormatPs.add(pPsCompression, t[54]);
	    pFormatPs.add(pPsAlpha, t[51]);
	    pFormatPs.add(pPsOperators, t[53]);
	  }
	  // pFormatPsOuter 90
	  pFormatPsOuter = new JPanel();
	  pFormatPsOuter.setBorder(
	    BorderFactory.createTitledBorder(t[103])
	  );
	  {
	    pFormatPsOuter.add(pFormatPs, BorderLayout.CENTER);
	  }
	  // pFormatPsOuterOuter 84
	  pFormatPsOuterOuter = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pFormatPsOuterOuter.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pFormatPsOuterOuter.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pFormatPsOuterOuter.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pFormatPsOuterOuter.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      2, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pFormatPsOuterOuter.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pFormatPsOuter, gbc);
	    pFormatPsOuterOuter.add(pFormatPsOuter);
	  }
	  // pPdfOptions 344
	  pPdfOptions = new JTabbedPane();
	  {
	    pPdfOptions.add(pPdfGeneral, t[106]);
	    pPdfOptions.add(pPdfSize, t[107]);
	    pPdfOptions.add(pPdfCompression, t[108]);
	    pPdfOptions.add(pPdfAlpha, t[109]);
	  }
	  // pPdfOuter 340
	  pPdfOuter = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pPdfOuter.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfOuter.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfOuter.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfOuter.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      2, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfOuter.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pPdfOptions, gbc);
	    pPdfOuter.add(pPdfOptions);
	  }
	  // pPdfOuterOuter 335
	  pPdfOuterOuter = new JPanel();
	  pPdfOuterOuter.setBorder(
	    BorderFactory.createTitledBorder(t[105])
	  );
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pPdfOuterOuter.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfOuterOuter.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfOuterOuter.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfOuterOuter.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      2, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pPdfOuterOuter.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pPdfOuter, gbc);
	    pPdfOuterOuter.add(pPdfOuter);
	  }
	  // pFormatPdf 85
	  pFormatPdf = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pFormatPdf.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pFormatPdf.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pFormatPdf.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pFormatPdf.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      2, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pFormatPdf.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pPdfOuterOuter, gbc);
	    pFormatPdf.add(pPdfOuterOuter);
	  }
	  // pFormatSpecificOptions 73
	  pFormatSpecificOptions = new JPanel();
	  {
	    pFormatSpecificOptions.setLayout(new CardLayout());
	    pFormatSpecificOptions.add(pFormatPsOuterOuter, t[47]);
	    pFormatSpecificOptions.add(pFormatPdf, t[48]);
	    pFormatSpecificOptions.add(pFormatBb, t[49]);
	  }
	  // pFullCustom 37
	  pFullCustom = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pFullCustom.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pFullCustom.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pFullCustom.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      5, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pFullCustom.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      5, 4, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pFullCustom.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pFullCustom.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pFullCustom.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lChooseDriver, gbc);
	    pFullCustom.add(lChooseDriver);
	    gbc = jLayoutGbc(
	      3, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbChooseDriver, gbc);
	    pFullCustom.add(cbChooseDriver);
	    gbc = jLayoutGbc(
	      1, 3, 4, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pFormatSpecificOptions, gbc);
	    pFullCustom.add(pFormatSpecificOptions);
	  }
	  // pOptions 17
	  pOptions = new JTabbedPane();
	  {
	    pOptions.add(pPredefined, t[34]);
	    pOptions.add(pFullCustom, t[35]);
	  }
	  // pa 12
	  pa = new JPanel();
	  {
	    pa.setLayout(new BoxLayout(pa, BoxLayout.PAGE_AXIS));
	    pa.add(Box.createRigidArea(new Dimension(0, border)));
	    pa.add(pMakeMode);
	    pa.add(Box.createRigidArea(new Dimension(0, border)));
	    pa.add(pOptions);
	    pa.add(Box.createRigidArea(new Dimension(0, border)));
	    pa.add(pButtons);
	    pa.add(Box.createRigidArea(new Dimension(0, border)));
	  }
	  // MAIN 0
	  setTitle(t[25]);
	  setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
	  {
	    Container cp = null;
	    cp = getContentPane();
	    GridBagLayout gbl = new GridBagLayout();
	    cp.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      2, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pa, gbc);
	    cp.add(pa);
	  }
	  pdfSizeRadioButtonGroup = new ButtonGroup();
	  pdfSizeRadioButtonGroup.add(rbPdfSizeChunk);
	  pdfSizeRadioButtonGroup.add(rbPdfSizeFit);
	  pdfSizeRadioButtonGroup.add(rbPdfSizeOneOne);
	  psSizeRadioButtonGroup = new ButtonGroup();
	  psSizeRadioButtonGroup.add(cbPsSizeMedia);
	  psSizeRadioButtonGroup.add(cbPsSizeOneOne);
	  psSizeRadioButtonGroup.add(cbPsSizeRes);
	  rbgConfigurations = new ButtonGroup();
	  rbgConfigurations.add(rbBuiltin);
	  rbgConfigurations.add(rbFromFile);
	  jLayoutResetSizes();
	  jLayoutGetSize(bCancel);
	  jLayoutGetSize(bDefaults);
	  jLayoutGetSize(bOK);
	  jLayoutGetSize(bReload);
	  jLayoutSetSize(bCancel);
	  jLayoutSetSize(bDefaults);
	  jLayoutSetSize(bOK);
	  jLayoutSetSize(bReload);
	  jLayoutResetSizes();
	  jLayoutGetSize(cbBuiltin);
	  jLayoutGetSize(cbFromFile);
	  jLayoutSetSize(cbBuiltin);
	  jLayoutSetSize(cbFromFile);
	  jLayoutResetSizes();
	  jLayoutGetSize(cbPdfFit);
	  jLayoutGetSize(cbPdfVersion);
	  jLayoutSetSize(cbPdfFit);
	  jLayoutSetSize(cbPdfVersion);
	  bCancel.addActionListener(this);
	  bDefaults.addActionListener(this);
	  bOK.addActionListener(this);
	  bReload.addActionListener(this);
	  cbChooseDriver.addItemListener(this);
	  cbPdfAlphaMask.addItemListener(this);
	  cbPdfAlphaMix.addItemListener(this);
	  cbPdfAlphaTransfer.addItemListener(this);
	  cbPdfIgnoreJfif.addItemListener(this);
	  cbPdfInterpol.addItemListener(this);
	  cbPdfVersion.addActionListener(this);
	  cbPsDct.addItemListener(this);
	  cbPsIgnoreJfif.addItemListener(this);
	  cbPsImageMask.addItemListener(this);
	  cbPsInterpolation.addItemListener(this);
	  cbPsMix.addItemListener(this);
	  cbPsOpDict.addItemListener(this);
	  cbPsRunLength.addItemListener(this);
	  cbPsSizeMedia.addActionListener(this);
	  cbPsSizeOneOne.addActionListener(this);
	  cbPsSizeRes.addActionListener(this);
	  cbPsVersion.addActionListener(this);
	  csPdfAlphaMix.addActionListener(this);
	  csPs.addActionListener(this);
	  rbBuiltin.addActionListener(this);
	  rbFromFile.addActionListener(this);
	  rbPdfSizeChunk.addActionListener(this);
	  rbPdfSizeFit.addActionListener(this);
	  rbPdfSizeOneOne.addActionListener(this);
	  addWindowListener(this);
	}
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.setup.end

// jlayout.cleanup.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	private void jLayoutCleanup()
	{
	  bCancel.removeActionListener(this);
	  bDefaults.removeActionListener(this);
	  bOK.removeActionListener(this);
	  bReload.removeActionListener(this);
	  cbChooseDriver.removeItemListener(this);
	  cbPdfAlphaMask.removeItemListener(this);
	  cbPdfAlphaMix.removeItemListener(this);
	  cbPdfAlphaTransfer.removeItemListener(this);
	  cbPdfIgnoreJfif.removeItemListener(this);
	  cbPdfInterpol.removeItemListener(this);
	  cbPdfVersion.removeActionListener(this);
	  cbPsDct.removeItemListener(this);
	  cbPsIgnoreJfif.removeItemListener(this);
	  cbPsImageMask.removeItemListener(this);
	  cbPsInterpolation.removeItemListener(this);
	  cbPsMix.removeItemListener(this);
	  cbPsOpDict.removeItemListener(this);
	  cbPsRunLength.removeItemListener(this);
	  cbPsSizeMedia.removeActionListener(this);
	  cbPsSizeOneOne.removeActionListener(this);
	  cbPsSizeRes.removeActionListener(this);
	  cbPsVersion.removeActionListener(this);
	  csPdfAlphaMix.removeActionListener(this);
	  csPs.removeActionListener(this);
	  rbBuiltin.removeActionListener(this);
	  rbFromFile.removeActionListener(this);
	  rbPdfSizeChunk.removeActionListener(this);
	  rbPdfSizeFit.removeActionListener(this);
	  rbPdfSizeOneOne.removeActionListener(this);
	}
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.cleanup.end



    public BmepsOptions(
        BmepsWindow b, DkTool d, DkGuiTool g,
        BmepsController c, String[] my_t
    )
    {
        super(b);
        // Keep controllers
        bmw = b; dkt = d; dkgt = g; bc = c; t = my_t;
        // Prepare variables
        myBool = new boolean[bc.myBool.length];
        myInt = new int[bc.myInt.length];
        myStr = new String[bc.myStr.length];
        psImageMaskOptions = new String[2];
        psImageMaskOptions[0] = t[70];
        psImageMaskOptions[1] = t[71];
        pdfFitOptions = new String[4];
        pdfFitOptions[0] = t[112];
        pdfFitOptions[1] = t[113];
        pdfFitOptions[2] = t[114];
        pdfFitOptions[3] = t[115];
        driverList = new String[3];
        driverList[0] = t[47];
        driverList[1] = t[48];
        driverList[2] = t[49];
        builtinConfigurations = bc.getBuiltinConfigurations();
        fileConfigurations = bc.getFileConfigurations();
        if(builtinConfigurations == null) {
            builtinConfigurations = new String[0];
        }
        if(fileConfigurations == null) {
            fileConfigurations = new String[0];
        }
	predNames = new String[6];
	predNames[0] = t[136];
	predNames[1] = t[137];
	predNames[2] = t[138];
	predNames[3] = t[139];
	predNames[4] = t[140];
	predNames[5] = t[141];
        // Add GUI components
        jLayoutSetup();
        // Set up other variables
        mustApplyCorrections = false;
        clFormatSpecificOptions =
                (CardLayout)(pFormatSpecificOptions.getLayout());
        setDefaultValues();
        correctGUI();
        mustApplyCorrections = true;
        // Pack (calculate sizes).
        pack();
    }

    /** Initialize GUI elements from controller settings. */
    public void getData() {
        bc.getData(myBool, myInt, myStr);
        mustApplyCorrections = false;
        // TODO: Data transfer from controller to window.
        cbMakeMode.setSelected(myBool[0]);
        cbDraftMode.setSelected(myBool[1]);
        pOptions.setSelectedIndex(myBool[2] ? 1 : 0);
        if((myInt[14] >= 0) && (myInt[14] < 6)) {
            cbPdfPredictor.setSelectedIndex(myInt[14]);
        } else {
            cbPdfPredictor.setSelectedIndex(0);
        }
        if(rbFromFile.isEnabled()) {
            if(myBool[3]) {
                rbFromFile.doClick();
            } else {
                rbBuiltin.doClick();
            }
        } else {
            rbBuiltin.doClick();
        }
        if(myStr[1] != null) {
            try {
                cbBuiltin.setSelectedItem(myStr[1]);
            } catch(Exception e) {}
        }
        if(myStr[4] != null) {
            if(rbFromFile.isEnabled()) {
                try {
                    cbFromFile.setSelectedItem(myStr[4]);
                } catch(Exception e) {}
            }
        }
        if((myInt[0] >= 0) && (myInt[0] <= 2)) {
            cbChooseDriver.setSelectedIndex(myInt[0]);
        } else {
            cbChooseDriver.setSelectedIndex(0);
        }
        if((myInt[1] >= 1) && (myInt[1] <= 3)) {
            cbPsVersion.setSelectedIndex(myInt[1] - 1);
        } else {
            cbPsVersion.setSelectedIndex(1);
        }
        cbEncapsulated.setSelected(myBool[4]);
        cbDsc.setSelected(myBool[5]);
        cbPsColored.setSelected(myBool[6]);
        cbPsInterpolation.setSelected(myBool[7]);
        cbPsIntJpeg.setSelected(myBool[8]);
        switch(myInt[2]) {
            case 2: {
                cbPsSizeMedia.doClick();
            } break;
            case 1: {
                cbPsSizeRes.doClick();
            } break;
            default: {
                cbPsSizeOneOne.doClick();
            } break;
        }
        if(myStr[2] != null) {
            try {
                cbPsSizePapers.setSelectedItem(myStr[2]);
            } catch(Exception e) {}
        }
        cbPsBinToAscii.setSelectedIndex(myBool[9] ? 1 : 0);
        cbPsRunLength.setSelected(myBool[10]);
        cbPsMultipleData.setSelected(myBool[11]);
        cbPsFlate.setSelected(myBool[12]);
        cbPsDct.setSelected(myBool[13]);
        cbPsIgnoreJfif.setSelected(myBool[14]);
        cbPsSof00.setSelected(myBool[15]);
        cbPsSof01.setSelected(myBool[16]);
        cbPsSof02.setSelected(myBool[17]);
        cbPsSof03.setSelected(myBool[18]);
        cbPsSof04.setSelected(myBool[19]);
        cbPsSof05.setSelected(myBool[20]);
        cbPsSof06.setSelected(myBool[21]);
        cbPsSof07.setSelected(myBool[22]);
        cbPsSof08.setSelected(myBool[23]);
        cbPsSof09.setSelected(myBool[24]);
        cbPsSof10.setSelected(myBool[25]);
        cbPsSof11.setSelected(myBool[26]);
        cbPsSof12.setSelected(myBool[27]);
        cbPsSof13.setSelected(myBool[28]);
        cbPsSof14.setSelected(myBool[29]);
        cbPsSof15.setSelected(myBool[30]);
        cbPsMix.setSelected(myBool[31]);
        cbPsIgnoreBgChunk.setSelected(myBool[32]);
        cbPsImageMask.setSelected(myBool[33]);
        cbPsImageMaskOptions.setSelectedIndex(myBool[34] ? 1 : 0);
        csPs.setColor(new Color(myInt[3], myInt[4], myInt[5]));
        cbPsOpDict.setSelected(myBool[35]);
        cbPsOpVmreclaim.setSelected(myBool[36]);
        cbPsOpShowpage.setSelected(myBool[37]);
        cbPdfVersion.setSelectedIndex(myInt[6]);
        cbPdfFit.setSelectedIndex(myInt[7]);
        cbPdfInterpol.setSelected(myBool[38]);
        cbPdfIntJpeg.setSelected(myBool[39]);
        switch(myInt[8]) {
            case 2: {
                rbPdfSizeFit.doClick();
            } break;
            case 1: {
                rbPdfSizeChunk.doClick();
            } break;
            default: {
                rbPdfSizeOneOne.doClick();
            } break;
        }
        if(myStr[3] != null) {
            try {
                cbPdfSizeFit.setSelectedItem(myStr[3]);
            } catch(Exception e) {}
        }
        cbPdfIgnoreJfif.setSelected(myBool[40]);
        cbPdfSof00.setSelected(myBool[41]);
        cbPdfSof01.setSelected(myBool[42]);
        cbPdfSof02.setSelected(myBool[43]);
        cbPdfSof03.setSelected(myBool[44]);
        cbPdfSof04.setSelected(myBool[45]);
        cbPdfSof05.setSelected(myBool[46]);
        cbPdfSof06.setSelected(myBool[47]);
        cbPdfSof07.setSelected(myBool[48]);
        cbPdfSof08.setSelected(myBool[49]);
        cbPdfSof09.setSelected(myBool[50]);
        cbPdfSof10.setSelected(myBool[51]);
        cbPdfSof11.setSelected(myBool[52]);
        cbPdfSof12.setSelected(myBool[53]);
        cbPdfSof13.setSelected(myBool[54]);
        cbPdfSof14.setSelected(myBool[55]);
        cbPdfSof15.setSelected(myBool[56]);
        cbPdfAlphaTransfer.setSelected(myBool[57]);
        cbPdfAlphaAttributes.setSelected(myBool[58]);
        cbPdfAlphaMix.setSelected(myBool[59]);
        cbPdfAlphaIngoreChunk.setSelected(myBool[60]);
        cbPdfAlphaMask.setSelected(myBool[61]);
        cbPdfAlphaMaskHow.setSelectedIndex(myBool[62] ? 1 : 0);
        csPdfAlphaMix.setColor(new Color(myInt[9], myInt[10], myInt[11]));
        csPs.setColor(new Color(myInt[3], myInt[4], myInt[5]));
        try {
            pFormatPs.setSelectedIndex(myInt[12]);
        } catch(Exception e) {}
        try {
            pPdfOptions.setSelectedIndex(myInt[13]);
        } catch(Exception e) {}
        mustApplyCorrections = true;
        changeListenerAction();
    }

    /** Save GUI elements to controller. */
    public void putData() {
        Color jc;
        // TODO: Data transfer from window to controller.
	myBool[0] = cbMakeMode.isSelected();
	myBool[1] = cbDraftMode.isSelected();
	myBool[2] = (pOptions.getSelectedIndex() > 0) ? true : false;
	myBool[3] = rbFromFile.isSelected();
	try {
	    myStr[1] = (String)cbBuiltin.getSelectedItem();
	} catch(Exception e) { myStr[1] = null; }
	try {
	    myStr[4] = (String)cbFromFile.getSelectedItem();
	} catch(Exception e) { myStr[4] = null; }
	myInt[0] = cbChooseDriver.getSelectedIndex();
        bc.putData(myBool, myInt, myStr);
	myInt[1] = cbPsVersion.getSelectedIndex() + 1;
	myBool[4] = cbEncapsulated.isSelected();
	myBool[5] = cbDsc.isSelected();
	myBool[6] = cbPsColored.isSelected();
	myBool[7] = cbPsInterpolation.isSelected();
	myBool[8] = cbPsIntJpeg.isSelected();
	if(cbPsSizeMedia.isSelected()) {
	    myInt[2] = 2;
	} else {
	    if(cbPsSizeRes.isSelected()) {
	        myInt[2] = 1;
	    } else {
	        myInt[2] = 0;
	    }
	}
	myStr[2] = (String)cbPsSizePapers.getSelectedItem();
	myBool[9] = (cbPsBinToAscii.getSelectedIndex() > 0 ? true : false);
	myBool[10] = cbPsRunLength.isSelected();
	myBool[11] = cbPsMultipleData.isSelected();
	myBool[12] = cbPsFlate.isSelected();
	myBool[13] = cbPsDct.isSelected();
	myBool[14] = cbPsIgnoreJfif.isSelected();
	myBool[15] = cbPsSof00.isSelected();
	myBool[16] = cbPsSof01.isSelected();
	myBool[17] = cbPsSof02.isSelected();
	myBool[18] = cbPsSof03.isSelected();
	myBool[19] = cbPsSof04.isSelected();
	myBool[20] = cbPsSof05.isSelected();
	myBool[21] = cbPsSof06.isSelected();
	myBool[22] = cbPsSof07.isSelected();
	myBool[23] = cbPsSof08.isSelected();
	myBool[24] = cbPsSof09.isSelected();
	myBool[25] = cbPsSof10.isSelected();
	myBool[26] = cbPsSof11.isSelected();
	myBool[27] = cbPsSof12.isSelected();
	myBool[28] = cbPsSof13.isSelected();
	myBool[29] = cbPsSof14.isSelected();
	myBool[30] = cbPsSof15.isSelected();
	myBool[31] = cbPsMix.isSelected();
	myBool[32] = cbPsIgnoreBgChunk.isSelected();
	myBool[33] = cbPsImageMask.isSelected();
	myBool[34] = (cbPsImageMaskOptions.getSelectedIndex() > 0 ? true : false);
	jc = csPs.getColor();
	myInt[3] = jc.getRed();
	myInt[4] = jc.getGreen();
	myInt[5] = jc.getBlue();
	myBool[35] = cbPsOpDict.isSelected();
	myBool[36] = cbPsOpVmreclaim.isSelected();
	myBool[37] = cbPsOpShowpage.isSelected();
	myInt[6] = cbPdfVersion.getSelectedIndex();
	myInt[7] = cbPdfFit.getSelectedIndex();
	myBool[38] = cbPdfInterpol.isSelected();
	myBool[39] = cbPdfIntJpeg.isSelected();
	if(rbPdfSizeFit.isSelected()) {
	    myInt[8] = 2;
	} else {
	    if(rbPdfSizeChunk.isSelected()) {
	        myInt[8] = 1;
	    } else {
	        myInt[8] = 0;
	    }
	}
	myStr[3] = (String)cbPdfSizeFit.getSelectedItem();
	myBool[40] = cbPdfIgnoreJfif.isSelected();
	myBool[41] = cbPdfSof00.isSelected();
	myBool[42] = cbPdfSof01.isSelected();
	myBool[43] = cbPdfSof02.isSelected();
	myBool[44] = cbPdfSof03.isSelected();
	myBool[45] = cbPdfSof04.isSelected();
	myBool[46] = cbPdfSof05.isSelected();
	myBool[47] = cbPdfSof06.isSelected();
	myBool[48] = cbPdfSof07.isSelected();
	myBool[49] = cbPdfSof08.isSelected();
	myBool[50] = cbPdfSof09.isSelected();
	myBool[51] = cbPdfSof10.isSelected();
	myBool[52] = cbPdfSof11.isSelected();
	myBool[53] = cbPdfSof12.isSelected();
	myBool[54] = cbPdfSof13.isSelected();
	myBool[55] = cbPdfSof14.isSelected();
	myBool[56] = cbPdfSof15.isSelected();
	myBool[57] = cbPdfAlphaTransfer.isSelected();
	myBool[58] = cbPdfAlphaAttributes.isSelected();
	myBool[59] = cbPdfAlphaMix.isSelected();
	myBool[60] = cbPdfAlphaIngoreChunk.isSelected();
	myBool[61] = cbPdfAlphaMask.isSelected();
	myBool[62] = (cbPdfAlphaMaskHow.getSelectedIndex() > 0 ? true : false);
	jc = csPdfAlphaMix.getColor();
	myInt[9] = jc.getRed();
	myInt[10] = jc.getGreen();
	myInt[11] = jc.getBlue();
        myInt[12] = pFormatPs.getSelectedIndex();
        myInt[13] = pPdfOptions.getSelectedIndex();
        myInt[14] = cbPdfPredictor.getSelectedIndex();
        bc.putData(myBool, myInt, myStr);
    }

    /** Do GUI corrections. */
    private void correctGUI() {
        boolean x;
        if(fileConfigurations.length > 0) {
            rbFromFile.setEnabled(true);
        } else {
            rbFromFile.setEnabled(false);
        }
        x = false;
        if(rbFromFile.isEnabled()) {
            if(rbFromFile.isEnabled()) {
                x = true;
            }
        }
        // if(!x) { cbFromFile.setSelectedIndex(0); }
        cbFromFile.setEnabled(x);
        x = false;
        if(rbBuiltin.isEnabled()) {
            if(rbBuiltin.isSelected())    {
                x = true;
            }
        }
        // if(!x) { cbBuiltin.setSelectedIndex(0); }
        cbBuiltin.setEnabled(true);
        if(cbPsVersion.getSelectedIndex() < 1) {
            cbPsColored.setEnabled(false);
            cbPsInterpolation.setEnabled(false);
            cbPsIntJpeg.setEnabled(false);
            cbPsBinToAscii.setSelectedIndex(0);
            cbPsBinToAscii.setEnabled(false);
            cbPsRunLength.setSelected(false);
            cbPsRunLength.setEnabled(false);
            cbPsDct.setSelected(false);
            cbPsDct.setEnabled(false);
            cbPsFlate.setSelected(false);
            cbPsFlate.setEnabled(false);
            cbPsImageMask.setSelected(false);
            cbPsImageMask.setEnabled(false);
            cbPsOpDict.setSelected(false);
            cbPsOpDict.setEnabled(false);
        } else {
            cbPsColored.setEnabled(true);
            cbPsInterpolation.setEnabled(true);
            cbPsIntJpeg.setEnabled(true);
            cbPsBinToAscii.setEnabled(true);
            cbPsRunLength.setEnabled(true);
            cbPsDct.setEnabled(true);
            cbPsOpDict.setEnabled(true);
            if(cbPsVersion.getSelectedIndex() < 2) {
                cbPsFlate.setSelected(false);
                cbPsFlate.setEnabled(false);
                cbPsImageMask.setSelected(false);
                cbPsImageMask.setEnabled(false);
            } else {
                cbPsFlate.setEnabled(true);
                cbPsImageMask.setEnabled(true);
            }
        }
        if(cbEncapsulated.isSelected()) {
            cbPsOpShowpage.setSelected(false);
            cbPsOpShowpage.setEnabled(false);
        } else {
            cbPsOpShowpage.setEnabled(true);
        }
        x = false;
        if(cbPsInterpolation.isEnabled()) {
            if(cbPsInterpolation.isSelected()) {
                x = true;
            }
        } cbPsIntJpeg.setEnabled(x);
        x = false;
        if(cbPsRunLength.isEnabled()) {
            if(cbPsRunLength.isSelected()) {
                x = true;
            }
        }
        if(!x) { cbPsMultipleData.setSelected(false); }
        cbPsMultipleData.setEnabled(x);
        x = false;
        if(cbPsDct.isEnabled()) {
            if(cbPsDct.isSelected()) {
                x = true;
            }
        }
        if(!x) { cbPsIgnoreJfif.setSelected(false); }
        cbPsIgnoreJfif.setEnabled(x);
        if(x) {
            cbPsSof00.setEnabled(true);
            cbPsSof01.setEnabled(true);
            cbPsSof02.setEnabled(true);
            cbPsSof03.setEnabled(true);
            cbPsSof04.setEnabled(true);
            cbPsSof05.setEnabled(true);
            cbPsSof06.setEnabled(true);
            cbPsSof07.setEnabled(true);
            cbPsSof08.setEnabled(true);
            cbPsSof09.setEnabled(true);
            cbPsSof10.setEnabled(true);
            cbPsSof11.setEnabled(true);
            cbPsSof12.setEnabled(true);
            cbPsSof13.setEnabled(true);
            cbPsSof14.setEnabled(true);
            cbPsSof15.setEnabled(true);
            if(cbPsIgnoreJfif.isSelected()) {
                cbPsSof00.setEnabled(false);
                cbPsSof01.setEnabled(false);
                cbPsSof02.setEnabled(false);
                cbPsSof03.setEnabled(false);
                cbPsSof04.setEnabled(false);
                cbPsSof05.setEnabled(false);
                cbPsSof06.setEnabled(false);
                cbPsSof07.setEnabled(false);
                cbPsSof08.setEnabled(false);
                cbPsSof09.setEnabled(false);
                cbPsSof10.setEnabled(false);
                cbPsSof11.setEnabled(false);
                cbPsSof12.setEnabled(false);
                cbPsSof13.setEnabled(false);
                cbPsSof14.setEnabled(false);
                cbPsSof15.setEnabled(false);
            }
        } else {
            cbPsSof00.setSelected(false);
            cbPsSof01.setSelected(false);
            cbPsSof02.setSelected(false);
            cbPsSof03.setSelected(false);
            cbPsSof04.setSelected(false);
            cbPsSof05.setSelected(false);
            cbPsSof06.setSelected(false);
            cbPsSof07.setSelected(false);
            cbPsSof08.setSelected(false);
            cbPsSof09.setSelected(false);
            cbPsSof10.setSelected(false);
            cbPsSof11.setSelected(false);
            cbPsSof12.setSelected(false);
            cbPsSof13.setSelected(false);
            cbPsSof14.setSelected(false);
            cbPsSof15.setSelected(false);
            cbPsSof00.setEnabled(false);
            cbPsSof01.setEnabled(false);
            cbPsSof02.setEnabled(false);
            cbPsSof03.setEnabled(false);
            cbPsSof04.setEnabled(false);
            cbPsSof05.setEnabled(false);
            cbPsSof06.setEnabled(false);
            cbPsSof07.setEnabled(false);
            cbPsSof08.setEnabled(false);
            cbPsSof09.setEnabled(false);
            cbPsSof10.setEnabled(false);
            cbPsSof11.setEnabled(false);
            cbPsSof12.setEnabled(false);
            cbPsSof13.setEnabled(false);
            cbPsSof14.setEnabled(false);
            cbPsSof15.setEnabled(false);
        }
        x = false;
        if(cbPsImageMask.isEnabled()) {
            if(cbPsImageMask.isSelected()) {
                x = true;
            }
        }
        cbPsImageMaskOptions.setEnabled(x);
        x = false;
        if(cbPsOpDict.isEnabled()) {
            if(cbPsOpDict.isSelected()) {
                x = true;
            }
        }
        if(!x) { cbPsOpVmreclaim.setSelected(false); }
        cbPsOpVmreclaim.setEnabled(x);
        if(cbPsSizeMedia.isSelected()) {
            cbPsSizePapers.setEnabled(true);
        } else {
            cbPsSizePapers.setEnabled(false);
        }
        x = false;
        if(cbPsMix.isEnabled()) {
            if(cbPsMix.isSelected()) {
                x = true;
            }
        }
        if(!x) { cbPsIgnoreBgChunk.setSelected(false); }
        cbPsIgnoreBgChunk.setEnabled(x);
        x = false;
        if(cbPdfInterpol.isEnabled()) {
            if(cbPdfInterpol.isSelected()) {
                x = true;
            }
        }
        if(!x) { cbPdfIntJpeg.setSelected(false); }
        cbPdfIntJpeg.setEnabled(x);
        if(rbPdfSizeFit.isSelected()) {
            cbPdfSizeFit.setEnabled(true);
        } else {
            cbPdfSizeFit.setEnabled(false);
        }
        x = false;
        if(cbPdfIgnoreJfif.isEnabled()) {
            if(cbPdfIgnoreJfif.isSelected()) {
                x = true;
            }
        }
        if(x) {
            cbPdfSof00.setEnabled(false);
            cbPdfSof01.setEnabled(false);
            cbPdfSof02.setEnabled(false);
            cbPdfSof03.setEnabled(false);
            cbPdfSof04.setEnabled(false);
            cbPdfSof05.setEnabled(false);
            cbPdfSof06.setEnabled(false);
            cbPdfSof07.setEnabled(false);
            cbPdfSof08.setEnabled(false);
            cbPdfSof09.setEnabled(false);
            cbPdfSof10.setEnabled(false);
            cbPdfSof11.setEnabled(false);
            cbPdfSof12.setEnabled(false);
            cbPdfSof13.setEnabled(false);
            cbPdfSof14.setEnabled(false);
            cbPdfSof15.setEnabled(false);
        } else {
            cbPdfSof00.setEnabled(true);
            cbPdfSof01.setEnabled(true);
            cbPdfSof02.setEnabled(true);
            cbPdfSof03.setEnabled(true);
            cbPdfSof04.setEnabled(true);
            cbPdfSof05.setEnabled(true);
            cbPdfSof06.setEnabled(true);
            cbPdfSof07.setEnabled(true);
            cbPdfSof08.setEnabled(true);
            cbPdfSof09.setEnabled(true);
            cbPdfSof10.setEnabled(true);
            cbPdfSof11.setEnabled(true);
            cbPdfSof12.setEnabled(true);
            cbPdfSof13.setEnabled(true);
            cbPdfSof14.setEnabled(true);
            cbPdfSof15.setEnabled(true);
        }
        if(cbPdfVersion.getSelectedIndex() > 1) {
            cbPdfAlphaTransfer.setEnabled(true);
        } else {
            cbPdfAlphaTransfer.setSelected(false);
            cbPdfAlphaTransfer.setEnabled(false);
        }
        x = false;
        if(cbPdfAlphaTransfer.isEnabled()) {
            if(cbPdfAlphaTransfer.isSelected()) {
                x = true;
            }
        }
        cbPdfAlphaAttributes.setEnabled(x);
        if(x) {
            cbPdfAlphaMix.setSelected(false);
            cbPdfAlphaMix.setEnabled(false);
            cbPdfAlphaMask.setSelected(false);
            cbPdfAlphaMask.setEnabled(false);
        } else {
            cbPdfAlphaMix.setEnabled(true);
            cbPdfAlphaMask.setEnabled(true);
        }
        x = false;
        if(cbPdfAlphaMix.isEnabled()) {
            if(cbPdfAlphaMix.isSelected()) {
                x = true;
            }
        }
        if(!x) { cbPdfAlphaIngoreChunk.setSelected(false); }
        cbPdfAlphaIngoreChunk.setEnabled(x);
        x = false;
        if(cbPdfAlphaMask.isEnabled()) {
            if(cbPdfAlphaMask.isSelected()) {
                x = true;
            }
        }
        if(!x) { cbPdfAlphaMaskHow.setSelectedIndex(0); }
        cbPdfAlphaMaskHow.setEnabled(x);
        try {
            clFormatSpecificOptions.show(
                pFormatSpecificOptions,
                (String)cbChooseDriver.getSelectedItem()
            );
        } catch(Exception exc) {}
    }


    /** Correct GUI if necessary (no correction just running). */
    private void changeListenerAction() {
        boolean must_run = false;
        if(mustApplyCorrections) {
            must_run = true;
            mustApplyCorrections = false;
        }
        if(must_run) {
            correctGUI();
            mustApplyCorrections = true;
        }
    }

    private void setDefaultValues() {
        cbMakeMode.setSelected(true);
        cbDraftMode.setSelected(false);
        rbBuiltin.doClick();
        cbBuiltin.setSelectedIndex(5);
        cbPsSizeOneOne.doClick();
        rbPdfSizeOneOne.doClick();
        cbPsVersion.setSelectedIndex(1);
        cbEncapsulated.setSelected(true);
        cbDsc.setSelected(false);
        cbPsColored.setSelected(true);
        cbPsInterpolation.setSelected(true);
        cbPsIntJpeg.setSelected(false);
        cbPsBinToAscii.setSelectedIndex(1);
        cbPsRunLength.setSelected(true);
        cbPsMultipleData.setSelected(true);
        cbPsFlate.setSelected(false);
        cbPsDct.setSelected(true);
        cbPsIgnoreJfif.setSelected(true);
        cbPsSof00.setSelected(true);
        cbPsSof01.setSelected(true);
        cbPsSof02.setSelected(false);
        cbPsSof03.setSelected(false);
        cbPsSof04.setSelected(false);
        cbPsSof05.setSelected(false);
        cbPsSof06.setSelected(false);
        cbPsSof07.setSelected(false);
        cbPsSof08.setSelected(false);
        cbPsSof09.setSelected(false);
        cbPsSof10.setSelected(false);
        cbPsSof11.setSelected(false);
        cbPsSof12.setSelected(false);
        cbPsSof13.setSelected(false);
        cbPsSof14.setSelected(false);
        cbPsSof15.setSelected(false);
        cbPsMix.setSelected(false);
        cbPsIgnoreBgChunk.setSelected(false);
        cbPsImageMask.setSelected(false);
        cbPsImageMaskOptions.setSelectedIndex(0);
        cbPsOpDict.setSelected(true);
        cbPsOpVmreclaim.setSelected(false);
        cbPsOpShowpage.setSelected(false);
        cbPsSizePapers.setSelectedIndex(1);
        cbPdfVersion.setSelectedIndex(2);
        cbPdfFit.setSelectedIndex(0);
        cbPdfInterpol.setSelected(true);
        cbPdfIntJpeg.setSelected(false);
        cbPdfSizeFit.setSelectedIndex(1);
        cbPdfIgnoreJfif.setSelected(true);
        cbPdfSof00.setSelected(true);
        cbPdfSof01.setSelected(true);
        cbPdfSof02.setSelected(false);
        cbPdfSof03.setSelected(false);
        cbPdfSof04.setSelected(false);
        cbPdfSof05.setSelected(false);
        cbPdfSof06.setSelected(false);
        cbPdfSof07.setSelected(false);
        cbPdfSof08.setSelected(false);
        cbPdfSof09.setSelected(false);
        cbPdfSof10.setSelected(false);
        cbPdfSof11.setSelected(false);
        cbPdfSof12.setSelected(false);
        cbPdfSof13.setSelected(false);
        cbPdfSof14.setSelected(false);
        cbPdfSof15.setSelected(false);
        cbPdfAlphaTransfer.setSelected(true);
        cbPdfAlphaAttributes.setSelected(true);
        cbPdfAlphaMix.setSelected(false);
        cbPdfAlphaIngoreChunk.setSelected(false);
        cbPdfAlphaMask.setSelected(false);
        cbPdfAlphaMaskHow.setSelectedIndex(0);
        cbPdfPredictor.setSelectedIndex(0);
    }

    private void setDefaults() {
        boolean ba = mustApplyCorrections;
        mustApplyCorrections = false;
        setDefaultValues();
        mustApplyCorrections = ba;
    }

    private void changeColor(ColorShowArea cs) {
        Color nc = JColorChooser.showDialog(this, t[125], cs.getColor());
        if(nc != null) {
            cs.setColor(nc);
        }
    }


    private int[] actionsToCheck = {
         26, // OK
         28, // Cancel
         30, // Reload
         32, // Defaults
         38, // Built-in configuration
         76, // PS size
         77, // PS size
         78, // PS size
        120, // PS Version changed
        121, // PDF version chanaged
        123, // Color PS
        124, // Color PDF
    };

    @Override
    public void actionPerformed(ActionEvent e) {
        // TODO: Actions for clicked buttons.
        String s = e.getActionCommand();
        int action = DkTool.getStringArrayIndex(t, s, actionsToCheck, false);
        switch(action) {
            case 26: {
                putData();
                setModal(false); setVisible(false);
            } break;
            case 28: {
	        getData();
                setModal(false); setVisible(false);
            } break;
            case 30: {
                getData();
                repaint();
            } break;
            case 32: {
                setDefaults();
                changeListenerAction();
                pOptions.setSelectedIndex(0);
                repaint();
            } break;
            case 38: {
                // TODO: Switch to built-in configuration
            } break;
            case 123: {
                changeColor(csPs);
            } break;
            case 124: {
                changeColor(csPdfAlphaMix);
            } break;
            default: {  // Changes in combo boxes
                changeListenerAction();
                repaint();
            } break;
        }
    }

    @Override
    public void itemStateChanged(ItemEvent e) {
        Object o = e.getSource();
        if(o == (Object)cbChooseDriver) {
            try {
                clFormatSpecificOptions.show(
                        pFormatSpecificOptions, (String)e.getItem()
                );
            } catch(Exception exc) {}
        } else {
            changeListenerAction();
        }
    }


    /**
     * Closing the window means the same as pressing the
     * "Cancel" button.
     *
     * @param e
     * The window event triggering the handler.
     */
    public void windowClosing(WindowEvent e)
    {
        getData();
	changeListenerAction();
        setModal(false);
        setVisible(false);
    }

    /**
     * Unused event handler.
     *
     * @param e
     * Window event triggering the handler.
     */
    public void windowActivated(WindowEvent e) {}

    /**
     * Unused event handler.
     *
     * @param e
     * Window event triggering the handler.
     */
    public void windowClosed(WindowEvent e) {}

    /**
     * Unused event handler.
     *
     * @param e
     * Window event triggering the handler.
     */
    public void windowDeactivated(WindowEvent e) {}

    /**
     * Unused event handler.
     *
     * @param e
     * Window event triggering the handler.
     */
    public void windowDeiconified(WindowEvent e) {}

    /**
     * Unused event handler.
     *
     * @param e
     * Window event triggering the handler.
     */
    public void windowIconified(WindowEvent e) {}

    /**
     * Unused event handler.
     *
     * @param e
     * Window event triggering the handler.
     */
    public void windowOpened(WindowEvent e) {}

}

