/*
Copyright (c) 2009, Dirk Krause
All rights reserved.

Redistribution and use in source and binary forms,
with or without modification, are permitted provided
that the following conditions are met:

* Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.
* Redistributions in binary form must reproduce the above
  opyright notice, this list of conditions and the following
  disclaimer in the documentation and/or other materials
  provided with the distribution.
* Neither the name of the Dirk Krause nor the names of
  contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE.
*/

package bmepsgui;

import java.io.File;
import java.io.InputStreamReader;
import java.io.BufferedReader;

import java.util.TreeMap;
import java.util.Set;

import java.net.URI;
import java.net.URL;

import java.awt.Desktop;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.awt.event.ActionListener;

import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import javax.swing.JFileChooser;


import dirk_krause.tools.*;

// jlayout.import.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
import java.awt.BorderLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Dimension;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Box;
import javax.swing.JPanel;
import javax.swing.JToolBar;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.ImageIcon;
import javax.swing.WindowConstants;
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.import.end



/**
 *
 * @author krause
 */
public class BmepsWindow
        extends DkFrame
        implements ActionListener
{
    /** Strings used in the program. */
    private String[] t = null;

    /** Flag: Currently running a conversion. */
    private boolean is_running = false;

    /** Bmeps controller. */
    private BmepsController bc = null;

    /** Options dialog. */
    private BmepsOptions bmod = null;

    /** Color green. */
    private Color cGreen = null;

    /** Color red. */
    private Color cRed = null;

    /** Text for local help. */
    private String helpText = null;

    private static final String[] kw = {
        /*   0 */ "<p>",
        /*   1 */ "</p>",
        /*   2 */ "<b>",
        /*   3 */ "</b>",
        /*   4 */ "<br>",
    };

    public static final String copyright =
        "<html>\n"
        + "<body>\n"
        + "<p>Bmeps GUI 1.0.2</p>"
        + "<p>Copyright (c) 2009, Dirk Krause<br>\n"
        + "All rights reserved.\n"
        + "</p>\n"
        + "<p>\n"
        + "Redistribution and use in source and binary forms,\n"
        + "with or without modification, are permitted provided\n"
        + "that the following conditions are met:\n"
        + "</p>\n"
        + "<ul>\n"
        + "<li>Redistributions of source code must retain the above\n"
        + "copyright notice, this list of conditions and the\n"
        + "following disclaimer.</li>\n"
        + "<li>Redistributions in binary form must reproduce the above \n"
        + "copyright notice, this list of conditions and the following\n"
        + "disclaimer in the documentation and/or other materials\n"
        + "provided with the distribution.</li>\n"
        + "<li>Neither the name of the Dirk Krause nor the names of\n"
        + "contributors may be used to endorse or promote\n"
        + "products derived from this software without specific\n"
        + "prior written permission.</li>\n"
        + "</ul>\n"
        + "<p>\n"
        + "THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND\n"
        + "CONTRIBUTORS ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,\n"
        + "INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF\n"
        + "MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE\n"
        + "DISCLAIMED.\n"
        + "IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE\n"
        + "LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,\n"
        + "EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT\n"
        + "LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;\n"
        + "LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\n"
        + "HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN\n"
        + "CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE\n"
        + "OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS\n"
        + "SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH\n"
        + "DAMAGE.\n"
        + "</p>\n"
        + "</body>\n"
        + "</html>\n";



// jlayout.variables.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	JButton bDirectory = null;
	JButton bExit = null;
	JButton bOptions = null;
	JButton bRun = null;
	JLabel lDirectory1 = null;
	JLabel lDirectory2 = null;
	JLabel lStatus1 = null;
	JLabel lStatus2 = null;
	JMenuItem mDirectory = null;
	JMenuItem mDocu = null;
	JMenuItem mExit = null;
	JMenu mFile = null;
	JMenuItem mGui = null;
	JMenu mHelp = null;
	JMenuItem mOptions = null;
	JMenuItem mRun = null;
	JMenu mSetup = null;
	JMenuItem mVersion = null;
	JMenuItem mWeb = null;
	JMenuBar mb = null;
	LogPanel pLog = null;
	JPanel pa = null;
	JToolBar tbButtons = null;
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.variables.end

// jlayout.setup.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	/**
	 * Find an image icon.
	 *
	 * @param n
	 * The name of the image icon file.
	 *
	 * @return
	 * The image icon.
	 */
	protected ImageIcon jLayoutImageIconFromName(String n)
	{
	  ImageIcon back = null;
	  try {
	    back = new ImageIcon(getClass().getResource(n));
	  }
	  catch(NullPointerException e) {
	    back = new ImageIcon(n);
	  }
	  return back;
	}
	/**
	 * Create GridBag constraints for a component.
	 *
	 * @param x
	 * The start grid column of the component.
	 *
	 * @param y
	 * The start grid line of the component.
	 *
	 * @param w
	 * The width of the component in grid columns.
	 *
	 * @param h
	 * The height of the component in grid lines.
	 *
	 * @param f
	 * The fill information (horizontal, vertical, both).
	 *
	 * @param wx
	 * The weight factor to grow the component horizontally
	 * when the container grows.
	 *
	 * @param wy
	 * The weight factor to grow the component vertically
	 * when the container grows.
	 */
	private GridBagConstraints jLayoutGbc(
	  int x, int y, int w, int h, int f, int a, double wx, double wy
	) {
	  GridBagConstraints back = new GridBagConstraints();
	  back.gridx = x;
	  back.gridy = y;
	  back.gridwidth = w;
	  back.gridheight = h;
	  back.fill = f;
	  back.anchor = a;
	  back.weightx = wx;
	  back.weighty = wy;
	  return back;
	}
	/**
	 * Create a dummy panel to ensure minimum distances.
	 *
	 * @param b
	 * The panels width and hight.
	 *
	 * @param rms
	 * A flag to indicate whether or not the panel must
	 * be set exactly to the given size (The panel can not grow).
	 */
	protected JPanel jLayoutCreateDistancePanel(int b, boolean rms)
	{
	  JPanel back = new JPanel();
	  Dimension d = new Dimension(b, b);
	  back.setMinimumSize(d);
	  back.setPreferredSize(d);
	  if(rms) {
	    back.setMaximumSize(d);
	  }
	  return back;
	}
	private void jLayoutSetup()
	{
	  // bDirectory 82
	  bDirectory = new JButton(jLayoutImageIconFromName(t[1]));
	  bDirectory.setActionCommand(t[5]);
	  bDirectory.setToolTipText(t[9]);
	  bDirectory.getAccessibleContext().setAccessibleDescription(
	    t[9]
	  );
	  // bExit 85
	  bExit = new JButton(jLayoutImageIconFromName(t[4]));
	  bExit.setActionCommand(t[8]);
	  bExit.setToolTipText(t[12]);
	  bExit.getAccessibleContext().setAccessibleDescription(
	    t[12]
	  );
	  // bOptions 83
	  bOptions = new JButton(jLayoutImageIconFromName(t[2]));
	  bOptions.setActionCommand(t[6]);
	  bOptions.setToolTipText(t[10]);
	  bOptions.getAccessibleContext().setAccessibleDescription(
	    t[10]
	  );
	  // bRun 84
	  bRun = new JButton(jLayoutImageIconFromName(t[3]));
	  bRun.setActionCommand(t[7]);
	  bRun.setToolTipText(t[11]);
	  bRun.getAccessibleContext().setAccessibleDescription(
	    t[11]
	  );
	  // lDirectory1 121
	  lDirectory1 = new JLabel(t[13]);
	  // lDirectory2 122
	  lDirectory2 = new JLabel(t[0]);
	  // lStatus1 124
	  lStatus1 = new JLabel(t[14]);
	  // lStatus2 125
	  lStatus2 = new JLabel(t[0]);
	  // mDirectory 25
	  mDirectory = new JMenuItem(t[5]);
	  mDirectory.setToolTipText(t[9]);
	  mDirectory.getAccessibleContext().setAccessibleDescription(
	    t[9]
	  );
	  // mDocu 63
	  mDocu = new JMenuItem(t[21]);
	  mDocu.setToolTipText(t[23]);
	  mDocu.getAccessibleContext().setAccessibleDescription(
	    t[23]
	  );
	  // mExit 28
	  mExit = new JMenuItem(t[8]);
	  mExit.setToolTipText(t[12]);
	  mExit.getAccessibleContext().setAccessibleDescription(
	    t[12]
	  );
	  // mGui 53
	  mGui = new JMenuItem(t[18]);
	  mGui.setToolTipText(t[19]);
	  mGui.getAccessibleContext().setAccessibleDescription(
	    t[19]
	  );
	  // mOptions 26
	  mOptions = new JMenuItem(t[6]);
	  mOptions.setToolTipText(t[10]);
	  mOptions.getAccessibleContext().setAccessibleDescription(
	    t[10]
	  );
	  // mRun 27
	  mRun = new JMenuItem(t[7]);
	  mRun.setToolTipText(t[11]);
	  mRun.getAccessibleContext().setAccessibleDescription(
	    t[11]
	  );
	  // mSetup 18
	  mSetup = new JMenu();
	  mSetup.setText(t[17]);
	  {
	    mSetup.add(mGui);
	  }
	  // mVersion 62
	  mVersion = new JMenuItem(t[128]);
	  mVersion.setToolTipText(t[129]);
	  mVersion.getAccessibleContext().setAccessibleDescription(
	    t[129]
	  );
	  // mWeb 64
	  mWeb = new JMenuItem(t[22]);
	  mWeb.setToolTipText(t[24]);
	  mWeb.getAccessibleContext().setAccessibleDescription(
	    t[24]
	  );
	  // pLog 123
	  pLog = new LogPanel();
	  // pa 13
	  pa = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pa.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.01, 0.01
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.01, 0.01
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.01, 0.01
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      4, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.01, 0.01
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.EAST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lDirectory1, gbc);
	    pa.add(lDirectory1);
	    gbc = jLayoutGbc(
	      3, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lDirectory2, gbc);
	    pa.add(lDirectory2);
	    gbc = jLayoutGbc(
	      1, 3, 3, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.WEST,
	      1, 1
	    );
	    gbl.setConstraints(pLog, gbc);
	    pa.add(pLog);
	    gbc = jLayoutGbc(
	      1, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.EAST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lStatus1, gbc);
	    pa.add(lStatus1);
	    gbc = jLayoutGbc(
	      3, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lStatus2, gbc);
	    pa.add(lStatus2);
	  }
	  // tbButtons 12
	  tbButtons = new JToolBar();
	  {
	    tbButtons.add(bDirectory);
	    tbButtons.add(bOptions);
	    tbButtons.add(bRun);
	    tbButtons.add(bExit);
	  }
	  // mFile 17
	  mFile = new JMenu();
	  mFile.setText(t[16]);
	  {
	    mFile.add(mDirectory);
	    mFile.add(mOptions);
	    mFile.add(mRun);
	    mFile.add(mExit);
	  }
	  // mHelp 20
	  mHelp = new JMenu();
	  mHelp.setText(t[20]);
	  {
	    mHelp.add(mVersion);
	    mHelp.add(mDocu);
	    mHelp.add(mWeb);
	  }
	  // mb 10
	  mb = new JMenuBar();
	  {
	    mb.add(mFile);
	    mb.add(mSetup);
	    mb.add(Box.createHorizontalGlue());
	    mb.add(mHelp);
	  }
	  // MAIN 0
	  setTitle(BmepsGuiMain.aName);
	  setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
	  {
	    setJMenuBar(mb);
	    Container cp = null;
	    cp = getContentPane();
	    cp.add(tbButtons, BorderLayout.PAGE_START);
	    cp.add(pa, BorderLayout.CENTER);
	  }
	  bDirectory.addActionListener(this);
	  bDirectory.setTransferHandler(drophandler);
	  bExit.addActionListener(this);
	  bExit.setTransferHandler(drophandler);
	  bOptions.addActionListener(this);
	  bOptions.setTransferHandler(drophandler);
	  bRun.addActionListener(this);
	  bRun.setTransferHandler(drophandler);
	  lDirectory1.setTransferHandler(drophandler);
	  lDirectory2.setTransferHandler(drophandler);
	  lStatus1.setTransferHandler(drophandler);
	  lStatus2.setTransferHandler(drophandler);
	  mDirectory.addActionListener(this);
	  mDocu.addActionListener(this);
	  mExit.addActionListener(this);
	  mGui.addActionListener(this);
	  mOptions.addActionListener(this);
	  mRun.addActionListener(this);
	  mVersion.addActionListener(this);
	  mWeb.addActionListener(this);
	  pLog.setTransferHandler(drophandler);
	  pa.setTransferHandler(drophandler);
	  tbButtons.setTransferHandler(drophandler);
	  mb.setTransferHandler(drophandler);
	  setTransferHandler(drophandler);
	}
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.setup.end

// jlayout.cleanup.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	private void jLayoutCleanup()
	{
	  bDirectory.removeActionListener(this);
	  bExit.removeActionListener(this);
	  bOptions.removeActionListener(this);
	  bRun.removeActionListener(this);
	  mDirectory.removeActionListener(this);
	  mDocu.removeActionListener(this);
	  mExit.removeActionListener(this);
	  mGui.removeActionListener(this);
	  mOptions.removeActionListener(this);
	  mRun.removeActionListener(this);
	  mVersion.removeActionListener(this);
	  mWeb.removeActionListener(this);
	}
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.cleanup.end



    class MyDropHandler extends OneDirectoryDropTransferHandler {
        protected boolean processFilename(String fn) {
            boolean back = true;
            if(!getIsRunning()) {
                useNewDirectory(fn);
            }
            return back;
        }
    }

    private MyDropHandler drophandler = null;

    class DirectoryLabelChanger implements Runnable {
        private String d = null;
        public DirectoryLabelChanger(String dn) {
            d = dn;
        }
        @Override
        public void run() {
            lDirectory2.setText(d);
        }
    }

    class LogChanger implements Runnable {
        private Color stc = null;
        private String stt = null;
        private String stm = null;
        private String log = null;
        private boolean is_html = false;
        public LogChanger(
            Color s, String t1, String t2, String l, boolean html
        )
        {
            stc = s;
            stt = t1;
            stm = t2;
            log = l;
            is_html = html;
        }
        @Override
        public void run() {
            lStatus1.setForeground(stc);
            lStatus1.setText(stt);
            lStatus2.setText(stm);
            pLog.setTextFromAwtThread(log, is_html);
            invalidate();
        }
    }

    class ConversionThread implements Runnable {
        @Override
        public void run() { conversionThread(); }
    }

    public BmepsWindow(DkTool d, DkGuiTool g, BmepsController b, String[] my_t)
    {
        super(BmepsGuiMain.aName, d, g);
        bc = b; t = my_t;
        /* Create objects. */
        drophandler = new MyDropHandler();
        cGreen = new Color(0, 127, 0);
        cRed = new Color(192, 0, 0);
        /* Create GUI. */
        jLayoutSetup();
        /* Set objects relations. */
        String s = bc.getString(0);
        if(s != null) { lDirectory2.setText(s); }
        lStatus1.setForeground(cGreen);
        /* Pack window. */
        pack();
    }


    private boolean getIsRunning() {
        boolean back = false;
        synchronized(this) {
            back = is_running;
        }
        return back;
    }



    private void setisRunning(boolean b) {
        synchronized(this) {
            is_running = b;
        }
    }


    private boolean canStartRun() {
        boolean back = true;
        synchronized(this) {
            if(is_running) {
                back = false;
            } else {
                // TODO: is_running = true;
            }
        }
        return back;
    }

    private BmepsOptions getOptionsDialog() {
        BmepsOptions back = null;
        synchronized(this) {
            back = bmod;
        }
        if(back == null) {
            back = new BmepsOptions(this, dkt, dkgt, bc, t);
            DkTool.chooseModalPosition(screenWidth, screenHeight, this, back);
            synchronized(this) {
                bmod = back;
            }
        }
        return back;
    }



    private String createEntireLogString(StringBuilder s) {
        String back = null;
        StringBuilder sb = new StringBuilder();
        sb.append("<html><body>");
        sb.append(s);
        sb.append("</body></html>");
        back = new String(sb);
        return back;
    }


    private String removeTrailingWhitespaces(String s) {
        String back = null;
	int l = s.length();
	int i;
	int spp = -1;
	char c;
	for(i = 0; i < l; i++) {
	    c = s.charAt(i);
	    switch(c) {
	         case ' ': case '\t': case '\n': case '\r': {
		     if(spp == -1) {
		         spp = i;
		     }
		 } break;
		 default: {
		     spp = -1;
		 } break;
	    }
	}
	if(spp == -1) {
	    back = s;
	} else {
	    back = s.substring(0, spp);
	}
	return back;
    }

    private void conversionThread() {
        StringBuilder sb;  // Contents text.
        sb = new StringBuilder();
        TreeMap<String,String[]> cmds = bc.createListOfCommands();
        Set<String> ks = cmds.keySet();
        Object[] objarray = ks.toArray();
        int currentIndex = 1;
        for(Object objfilename: objarray) {
            String filename = (String)objfilename;
            String l = createEntireLogString(sb);
            SwingUtilities.invokeLater(
                new LogChanger(cRed, t[15], filename, l, true)
            );
            sb.append(kw[0]);
            sb.append(dkt.encodeToHtml(filename));
            //sb.append(String.format(" (%d/%d)",currentIndex,objarray.length));
	    sb.append(" (");
	    sb.append((new Integer(currentIndex)).toString());
	    sb.append("/");
	    sb.append((new Integer(objarray.length)).toString());
	    sb.append(")");
            sb.append(kw[4]);
            try {
                String[] conversionCommand = cmds.get((String)objfilename);
                if(conversionCommand != null) {
                    if(conversionCommand.length > 0) {
                        StringBuilder cmdsb = new StringBuilder();
                        for(int x = 0; x < conversionCommand.length; x++) {
                            if(x > 0) {
                                sb.append("&nbsp;");
                            }
                            sb.append(dkt.encodeToHtml(conversionCommand[x]));
                        }
                        sb.append(kw[4]);
                        try {
                            ProcessBuilder pb =
                            new ProcessBuilder(conversionCommand);
                            File inputFile = new File(filename);
                            String dirname = inputFile.getParent();
                            if(dirname != null) pb.directory(new File(dirname));
                            Process p = pb.start();
                            InputStreamReader isr =
                            new InputStreamReader(p.getInputStream(), "UTF-8");
                            BufferedReader in = new BufferedReader(isr);
                            for(String il; (il = in.readLine()) != null; ) {
                                // String nl = il.trim();
				String nl = removeTrailingWhitespaces(il);
                                boolean bold_flag = true;
                                if(nl.startsWith("#")) {
                                    bold_flag = false;
                                }
                                if(bold_flag) {
                                    sb.append(kw[2]);
                                }
                                sb.append(dkt.encodeToHtml(nl));
                                if(bold_flag) {
                                    sb.append(kw[3]);
                                }
                                sb.append(kw[4]);
                            }
                            if(in != null) {
                                try { in.close(); } catch(Exception e) {}
                            }
                            if(isr != null) {
                                try { isr.close(); } catch(Exception e) {}
                            }
                            in = null; isr = null;
                            isr = new InputStreamReader(p.getErrorStream(), "UTF-8");
                            in = new BufferedReader(isr);
                            for(String il; (il = in.readLine()) != null; ) {
                                // TODO: Process input line.
                            }
                            if(in != null) {
                                try { in.close(); } catch(Exception e) {}
                            }
                            if(isr != null) {
                                try { isr.close(); } catch(Exception e) {}
                            }
                            in = null; isr = null;
                            try { p.waitFor(); } catch(Exception e) {
                                sb.append(kw[2]);
                                sb.append(dkt.encodeToHtml(t[126]));
                                sb.append(kw[3]);
                                sb.append(kw[4]);
                            }
                            try {
                                if(p.exitValue() != 0) {
                                    sb.append(dkt.encodeToHtml(t[126]));
                                    sb.append(kw[3]);
                                    sb.append(kw[4]);
                                }
                            } catch(Exception e) {
                                sb.append(kw[2]);
                                sb.append(dkt.encodeToHtml(t[126]));
                                sb.append(kw[3]);
                                sb.append(kw[4]);
                            }
                        } catch(Exception e) {
                            sb.append(kw[2]);
                            sb.append(dkt.encodeToHtml(t[126]));
                            sb.append(kw[3]);
                            sb.append(kw[4]);
                        }
                    }
                }
            } catch(Exception e) {}
            sb.append(kw[1]);
            /*
            String l = createEntireLogString(sb);
            SwingUtilities.invokeLater(
                new LogChanger(cRed, t[15], filename, l, true)
            );
            */
            currentIndex++;
        }
        String l = createEntireLogString(sb);
        SwingUtilities.invokeLater(new LogChanger(cGreen, t[14], "", l, true));
        synchronized(this) { is_running = false; }
    }

    private void runConversion() {
        Thread thr = new Thread(new ConversionThread());
        thr.start();
    }


    public void useNewDirectory(String dn) {
        bc.setString(0, dn);
        SwingUtilities.invokeLater(new DirectoryLabelChanger(dn));
    }

    private void changeDirectory() {
        String d = bc.getString(0);
        JFileChooser c;
        if(d != null) { c = new JFileChooser(d); }
        else { c = new JFileChooser(); }
        c.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int result = c.showOpenDialog(this);
        if(result == JFileChooser.APPROVE_OPTION) {
            d = c.getSelectedFile().getAbsolutePath();
            useNewDirectory(d);
        }
    }

    private void showOptionsDialog() {
        BmepsOptions od = getOptionsDialog();
        od.getData();
        od.setModal(true);
        od.setVisible(true);
    }



    private void openLocalHelp() {
        String ht;
        synchronized(this) {
            ht = helpText;
        }
        if(ht == null) {
            ht = dkt.getLocalizedString(this, t[130], "UTF-8");
            if(ht != null) {
                synchronized(this) {
                    helpText = ht;
                }
            }
        }
        if(ht != null) {
            this.showMessageDialog(t[131], ht, true);
        } else {
            try {
            JOptionPane.showMessageDialog(
                this, t[133], t[134], JOptionPane.ERROR_MESSAGE
            );
            } catch(Exception e) {}
        }
    }


    private void openWebHelp() {
        try {
            Desktop.getDesktop().browse(new URI(t[132]));
        } catch(Exception exc) {}
    }



    public void cleanup(boolean isLast) {
        if(isLast) {
            bc.saveSettings();
        }
        jLayoutCleanup();
    }

    private final int[] actionsToCheck = {
        5,      // Directory
        6,      // Options
        7,      // Run
        8,      // Exit
        18,     // Setup / GUI
        21,     // Documentation
        22,     // Web site
        128,    // Version and license
    };

    public void actionPerformed(ActionEvent e) {
        int action = DkTool.getStringArrayIndex(
            t, e.getActionCommand(), actionsToCheck, false
        );
        switch(action) {
            case 5: {   // Directory
                if(!getIsRunning()) {
                    changeDirectory();
                }
            } break;
            case 6: {   // Options
                if(!getIsRunning()) {
                    showOptionsDialog();
                }
            } break;
            case 7: {   // Run
                if(canStartRun()) {
                    runConversion();
                }
            } break;
            case 8: {   // Exit
                if(!getIsRunning()) {
                    processWindowEvent(
                        new WindowEvent(this, WindowEvent.WINDOW_CLOSING)
                    );
                }
            } break;
            case 18: {  // Setup -> GUI
                if(!getIsRunning()) {
                    showGuiDialog();
                }
            } break;
            case 21: {  // Local docu
                openLocalHelp();
            } break;
            case 22: {  // Web site
                openWebHelp();
            } break;
            case 128: {
                showMessageDialog(t[128], copyright, true);
            } break;
        }
    }
}
