/*
Copyright (c) 2009, Dirk Krause
All rights reserved.

Redistribution and use in source and binary forms,
with or without modification, are permitted provided
that the following conditions are met:

* Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.
* Redistributions in binary form must reproduce the above
  opyright notice, this list of conditions and the following
  disclaimer in the documentation and/or other materials
  provided with the distribution.
* Neither the name of the Dirk Krause nor the names of
  contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE.
*/

package dirk_krause.tools;


// jlayout.import.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Dimension;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JComponent;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import javax.swing.WindowConstants;
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.import.end

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;
import javax.swing.JDialog;
import javax.swing.JOptionPane;

/**
 * Dialog box to set up the GUI (fonts, font sizes etc).
 * @author krause
 */
public class DkGuiDialog
        extends JDialog
        implements ActionListener
{
    /** File name for localized texts. */
    public static final String localized_text_file = "dkguiset.txt";

    /** Defaults for texts shown in the dialog.
     *  Use the ``dkguiset.txt'' file to provide localized texts.
     */
    private static final String[] def_t = {
        /*   0 */ "GUI setup",
        /*   1 */ "<html><body><b>General appearance</b></body></html>",
        /*   2 */ "<html><body><b>Fonts</b></body></html>",
        /*   3 */ "<html><body><b>Save options</b></body></html>",
        /*   4 */ "Look-and-feel: ",
        /*   5 */ "Space between components: ",
        /*   6 */ "Require minimum font size: ",
        /*   7 */ "Replace font family:",
        /*   8 */ " by: ",
        /*   9 */ "Save these settings as: ",
        /*  10 */ "Application settings",
        /*  11 */ "Application and application group settings",
        /*  12 */ "Application and group settings and general defaults",
        /*  13 */ "Attempt to save settings system-wide",
        /*  14 */ "OK",
        /*  15 */ "Cancel",
        /*  16 */ "Reset",
        /*  17 */ "Defaults",
        /*  18 */ "Fonts before customization: ",
        /*  19 */ "Fonts with customization: ",
        /*  20 */ "System look-and-feel",
        /*  21 */ "Java look-and-feel",
        /*  22 */ "Font Information",
        /*  23 */ "",
        /*  24 */ "5",
        /*  25 */ "12",
        /*  26 */ "<html><body><table><tr><td align=\"RIGHT\">Fonts before substitution:&nbsp;</td><td>",
        /*  27 */ "</td></tr><tr><td align=\"RIGHT\">Fonts after substitution:&nbsp;</td><td>",
        /*  28 */ "</td></tr></table></body></html>",
        /*  29 */ "Used Fonts",
        /*  30 */ "The changed settings are used if you restart the application.",
        /*  31 */ "You should exit and restart the application",
	/*  32 */ "Choose a look-and-feel",
	/*  33 */ "Space between GUI components (number of pixels)",
	/*  34 */ "Enforce a font size of at least ...",
	/*  35 */ "Font size to enforce",
	/*  36 */ "Show information about used fonts",
	/*  37 */ "Replace all occurances of one font family by another",
	/*  38 */ "Name of font family to replace",
	/*  39 */ "Name of font family to use instead",
	/*  40 */ "Where to apply the GUI settings",
	/*  41 */ "Administrative users can attempt to write to system preferences nodes",
	/*  42 */ "Confirm settings and close dialog",
	/*  43 */ "Discard settings and close dialog",
	/*  44 */ "Reload current settings to dialog",
	/*  45 */ "Suggest reasonable defaults",
    };

    /** The texts shown in the dialog box. */
    private String[] t = null;

    /** The DkTool object. */
    private DkTool dkt = null;

    /** The DkGuiTool object. */
    private DkGuiTool dkgt = null;

    /** Space between components. */
    private int b = 5;

    /** Texts for the look-and-feel combo box, filled by constructor. */
    private String[] textForLafCb = null;

    /** Texts for the save for dialog box, filled by constructor. */
    private String[] textForSaveCb = null;



// jlayout.variables.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	private int jLayoutSizeMinX = 0;
	private int jLayoutSizeMinY = 0;
	private int jLayoutSizePrefX = 0;
	private int jLayoutSizePrefY = 0;
	private int jLayoutSizeMaxX = 0;
	private int jLayoutSizeMaxY = 0;
	JButton bCancel = null;
	JButton bDefaults = null;
	JButton bFontInfo = null;
	JButton bOK = null;
	JButton bReset = null;
	JComboBox cbLAF = null;
	JCheckBox cbMinimum = null;
	JCheckBox cbReplace1 = null;
	JComboBox cbSaveStage = null;
	JCheckBox cbSystemSave = null;
	JLabel lBorder = null;
	JLabel lFonts = null;
	JLabel lGeneralAppearance = null;
	JLabel lLAF = null;
	JLabel lReplace2 = null;
	JLabel lSaveOptions = null;
	JLabel lSaveStage = null;
	JPanel pa = null;
	JPanel paButtons = null;
	JPanel paData = null;
	JTextField tBorder = null;
	JTextField tMinimum = null;
	JTextField tReplace1 = null;
	JTextField tReplace2 = null;
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.variables.end

// jlayout.setup.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	/**
	 * Reset the stored size informatio.
	 */
	private void jLayoutResetSizes()
	{
	  jLayoutSizeMinX = 0; jLayoutSizeMinY = 0;
	  jLayoutSizeMaxX = 0; jLayoutSizeMaxY = 0;
	  jLayoutSizePrefX = 0; jLayoutSizePrefY = 0;
	}
	private void jLayoutGetSize(JComponent c)
	{
	  Dimension d;
	  d = c.getMinimumSize();
	  if(d.width > jLayoutSizeMinX) { jLayoutSizeMinX = d.width; }
	  if(d.height > jLayoutSizeMinY) { jLayoutSizeMinY = d.height; }
	  d = c.getPreferredSize();
	  if(d.width > jLayoutSizePrefX) { jLayoutSizePrefX = d.width; }
	  if(d.height > jLayoutSizePrefY) { jLayoutSizePrefY = d.height; }
	  d = c.getMaximumSize();
	  if(d.width > jLayoutSizeMaxX) { jLayoutSizeMaxX = d.width; }
	  if(d.height > jLayoutSizeMaxY) { jLayoutSizeMaxY = d.height; }
	}
	/**
	 * Set a components size to a given minimum (save as other
	 * components).
	 *
	 * @param c
	 * The component to change.
	 */
	private void jLayoutSetSize(JComponent c)
	{
	  c.setMinimumSize(new Dimension(jLayoutSizeMinX, jLayoutSizeMinY));
	  c.setPreferredSize(new Dimension(jLayoutSizePrefX, jLayoutSizePrefY));
	  c.setMaximumSize(new Dimension(jLayoutSizeMaxX, jLayoutSizeMaxY));
	}
	/**
	 * Create GridBag constraints for a component.
	 *
	 * @param x
	 * The start grid column of the component.
	 *
	 * @param y
	 * The start grid line of the component.
	 *
	 * @param w
	 * The width of the component in grid columns.
	 *
	 * @param h
	 * The height of the component in grid lines.
	 *
	 * @param f
	 * The fill information (horizontal, vertical, both).
	 *
	 * @param wx
	 * The weight factor to grow the component horizontally
	 * when the container grows.
	 *
	 * @param wy
	 * The weight factor to grow the component vertically
	 * when the container grows.
	 */
	private GridBagConstraints jLayoutGbc(
	  int x, int y, int w, int h, int f, int a, double wx, double wy
	) {
	  GridBagConstraints back = new GridBagConstraints();
	  back.gridx = x;
	  back.gridy = y;
	  back.gridwidth = w;
	  back.gridheight = h;
	  back.fill = f;
	  back.anchor = a;
	  back.weightx = wx;
	  back.weighty = wy;
	  return back;
	}
	/**
	 * Create a dummy panel to ensure minimum distances.
	 *
	 * @param b
	 * The panels width and hight.
	 *
	 * @param rms
	 * A flag to indicate whether or not the panel must
	 * be set exactly to the given size (The panel can not grow).
	 */
	protected JPanel jLayoutCreateDistancePanel(int b, boolean rms)
	{
	  JPanel back = new JPanel();
	  Dimension d = new Dimension(b, b);
	  back.setMinimumSize(d);
	  back.setPreferredSize(d);
	  if(rms) {
	    back.setMaximumSize(d);
	  }
	  return back;
	}
	private void jLayoutSetup()
	{
	  // bCancel 116
	  bCancel = new JButton(t[15]);
	  bCancel.setToolTipText(t[43]);
	  bCancel.getAccessibleContext().setAccessibleDescription(
	    t[43]
	  );
	  // bDefaults 120
	  bDefaults = new JButton(t[17]);
	  bDefaults.setToolTipText(t[45]);
	  bDefaults.getAccessibleContext().setAccessibleDescription(
	    t[45]
	  );
	  // bFontInfo 29
	  bFontInfo = new JButton(t[22]);
	  bFontInfo.setToolTipText(t[36]);
	  bFontInfo.getAccessibleContext().setAccessibleDescription(
	    t[36]
	  );
	  // bOK 114
	  bOK = new JButton(t[14]);
	  bOK.setToolTipText(t[42]);
	  bOK.getAccessibleContext().setAccessibleDescription(
	    t[42]
	  );
	  // bReset 118
	  bReset = new JButton(t[16]);
	  bReset.setToolTipText(t[44]);
	  bReset.getAccessibleContext().setAccessibleDescription(
	    t[44]
	  );
	  // cbLAF 23
	  cbLAF = new JComboBox(textForLafCb);
	  cbLAF.setToolTipText(t[32]);
	  cbLAF.getAccessibleContext().setAccessibleDescription(
	    t[32]
	  );
	  // cbMinimum 27
	  cbMinimum = new JCheckBox(t[6]);
	  cbMinimum.setToolTipText(t[34]);
	  cbMinimum.getAccessibleContext().setAccessibleDescription(
	    t[34]
	  );
	  // cbReplace1 30
	  cbReplace1 = new JCheckBox(t[7]);
	  cbReplace1.setToolTipText(t[37]);
	  cbReplace1.getAccessibleContext().setAccessibleDescription(
	    t[37]
	  );
	  // cbSaveStage 36
	  cbSaveStage = new JComboBox(textForSaveCb);
	  cbSaveStage.setToolTipText(t[40]);
	  cbSaveStage.getAccessibleContext().setAccessibleDescription(
	    t[40]
	  );
	  // cbSystemSave 37
	  cbSystemSave = new JCheckBox(t[13]);
	  cbSystemSave.setToolTipText(t[41]);
	  cbSystemSave.getAccessibleContext().setAccessibleDescription(
	    t[41]
	  );
	  // lBorder 24
	  lBorder = new JLabel(t[5]);
	  // lFonts 26
	  lFonts = new JLabel(t[2]);
	  // lGeneralAppearance 21
	  lGeneralAppearance = new JLabel(t[1]);
	  // lLAF 22
	  lLAF = new JLabel(t[4]);
	  // lReplace2 32
	  lReplace2 = new JLabel(t[8]);
	  // lSaveOptions 34
	  lSaveOptions = new JLabel(t[3]);
	  // lSaveStage 35
	  lSaveStage = new JLabel(t[9]);
	  // paButtons 17
	  paButtons = new JPanel();
	  {
	    paButtons.setLayout(new BoxLayout(paButtons, BoxLayout.LINE_AXIS));
	    paButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    paButtons.add(Box.createHorizontalGlue());
	    paButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    paButtons.add(bOK);
	    paButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    paButtons.add(Box.createHorizontalGlue());
	    paButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    paButtons.add(bCancel);
	    paButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    paButtons.add(Box.createHorizontalGlue());
	    paButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    paButtons.add(bReset);
	    paButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    paButtons.add(Box.createHorizontalGlue());
	    paButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    paButtons.add(bDefaults);
	    paButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    paButtons.add(Box.createHorizontalGlue());
	    paButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	  }
	  // tBorder 25
	  tBorder = new JTextField(5);
	  tBorder.setToolTipText(t[33]);
	  tBorder.getAccessibleContext().setAccessibleDescription(
	    t[33]
	  );
	  // tMinimum 28
	  tMinimum = new JTextField(5);
	  tMinimum.setToolTipText(t[35]);
	  tMinimum.getAccessibleContext().setAccessibleDescription(
	    t[35]
	  );
	  // tReplace1 31
	  tReplace1 = new JTextField(10);
	  tReplace1.setToolTipText(t[38]);
	  tReplace1.getAccessibleContext().setAccessibleDescription(
	    t[38]
	  );
	  // tReplace2 33
	  tReplace2 = new JTextField(10);
	  tReplace2.setToolTipText(t[39]);
	  tReplace2.getAccessibleContext().setAccessibleDescription(
	    t[39]
	  );
	  // paData 16
	  paData = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    paData.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    paData.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 18, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    paData.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      8, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    paData.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      8, 18, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    paData.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paData.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paData.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      6, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paData.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paData.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paData.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paData.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 8, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paData.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 10, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paData.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 12, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paData.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 14, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paData.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 16, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    paData.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 7, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lGeneralAppearance, gbc);
	    paData.add(lGeneralAppearance);
	    gbc = jLayoutGbc(
	      1, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.EAST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lLAF, gbc);
	    paData.add(lLAF);
	    gbc = jLayoutGbc(
	      3, 3, 5, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbLAF, gbc);
	    paData.add(cbLAF);
	    gbc = jLayoutGbc(
	      1, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.EAST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lBorder, gbc);
	    paData.add(lBorder);
	    gbc = jLayoutGbc(
	      3, 5, 5, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(tBorder, gbc);
	    paData.add(tBorder);
	    gbc = jLayoutGbc(
	      1, 7, 7, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lFonts, gbc);
	    paData.add(lFonts);
	    gbc = jLayoutGbc(
	      1, 9, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbMinimum, gbc);
	    paData.add(cbMinimum);
	    gbc = jLayoutGbc(
	      3, 9, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(tMinimum, gbc);
	    paData.add(tMinimum);
	    gbc = jLayoutGbc(
	      7, 9, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(bFontInfo, gbc);
	    paData.add(bFontInfo);
	    gbc = jLayoutGbc(
	      1, 11, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbReplace1, gbc);
	    paData.add(cbReplace1);
	    gbc = jLayoutGbc(
	      3, 11, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(tReplace1, gbc);
	    paData.add(tReplace1);
	    gbc = jLayoutGbc(
	      5, 11, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lReplace2, gbc);
	    paData.add(lReplace2);
	    gbc = jLayoutGbc(
	      7, 11, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(tReplace2, gbc);
	    paData.add(tReplace2);
	    gbc = jLayoutGbc(
	      1, 13, 7, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lSaveOptions, gbc);
	    paData.add(lSaveOptions);
	    gbc = jLayoutGbc(
	      1, 15, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.EAST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lSaveStage, gbc);
	    paData.add(lSaveStage);
	    gbc = jLayoutGbc(
	      3, 15, 5, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbSaveStage, gbc);
	    paData.add(cbSaveStage);
	    gbc = jLayoutGbc(
	      1, 17, 7, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbSystemSave, gbc);
	    paData.add(cbSystemSave);
	  }
	  // pa 12
	  pa = new JPanel();
	  {
	    pa.setLayout(new BoxLayout(pa, BoxLayout.PAGE_AXIS));
	    pa.add(Box.createRigidArea(new Dimension(0, b)));
	    pa.add(paData);
	    pa.add(Box.createRigidArea(new Dimension(0, b)));
	    pa.add(paButtons);
	    pa.add(Box.createRigidArea(new Dimension(0, b)));
	  }
	  // MAIN 0
	  setTitle(t[0]);
	  setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
	  {
	    Container cp = null;
	    cp = getContentPane();
	    GridBagLayout gbl = new GridBagLayout();
	    cp.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      2, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pa, gbc);
	    cp.add(pa);
	  }
	  jLayoutResetSizes();
	  jLayoutGetSize(bCancel);
	  jLayoutGetSize(bDefaults);
	  jLayoutGetSize(bOK);
	  jLayoutGetSize(bReset);
	  jLayoutSetSize(bCancel);
	  jLayoutSetSize(bDefaults);
	  jLayoutSetSize(bOK);
	  jLayoutSetSize(bReset);
	  jLayoutResetSizes();
	  jLayoutGetSize(bFontInfo);
	  jLayoutGetSize(tReplace1);
	  jLayoutGetSize(tReplace2);
	  jLayoutSetSize(bFontInfo);
	  jLayoutSetSize(tReplace1);
	  jLayoutSetSize(tReplace2);
	  bCancel.addActionListener(this);
	  bDefaults.addActionListener(this);
	  bFontInfo.addActionListener(this);
	  bOK.addActionListener(this);
	  bReset.addActionListener(this);
	}
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.setup.end

// jlayout.cleanup.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	private void jLayoutCleanup()
	{
	  bCancel.removeActionListener(this);
	  bDefaults.removeActionListener(this);
	  bFontInfo.removeActionListener(this);
	  bOK.removeActionListener(this);
	  bReset.removeActionListener(this);
	}
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.cleanup.end


    /**
     * Constructor.
     * @param p The parent frame.
     * @param d DkTool object.
     * @param g DkGuiTool object.
     */
    public DkGuiDialog(JFrame p, DkTool d, DkGuiTool g) {
        super(p);
        dkt = d; dkgt = g;
        t = def_t;
        String[] my_t = d.getLocalizedArray(p, localized_text_file, "UTF-8");
        if(my_t != null) {
            if(my_t.length >= def_t.length) {
                t = my_t;
            } else {
            }
        } else {
        }
        b = dkgt.getComponentBorder();
        textForLafCb = new String[2];
        textForLafCb[0] = t[20];
        textForLafCb[1] = t[21];
        textForSaveCb = new String[3];
        textForSaveCb[0] = t[10];
        textForSaveCb[1] = t[11];
        textForSaveCb[2] = t[12];
        jLayoutSetup();
        pack();

    }

    /**
     * Transfer data from DkGuiTool object to dialog.
     */
    public void dataGet() {
        int lafIndex = dkgt.getLafIndex();
        if(lafIndex < 0) lafIndex = 0;
        try {
            cbLAF.setSelectedIndex(lafIndex);
        } catch(Exception e) { lafIndex = -1; }
        if(lafIndex < 0) lafIndex = 0;
        try {
            cbLAF.setSelectedIndex(lafIndex);
        } catch(Exception e) { lafIndex = -1; }
        lafIndex = dkgt.getComponentBorder();
        // tBorder.setText(String.format("%d", lafIndex));
	tBorder.setText((new Integer(lafIndex)).toString());
        int minFontSize = dkgt.getMinimumFontSize();
        if(minFontSize > 0) {
            cbMinimum.setSelected(true);
            // tMinimum.setText(String.format("%d", minFontSize));
	    tMinimum.setText((new Integer(minFontSize)).toString());
        } else {
            cbMinimum.setSelected(false);
            tMinimum.setText(t[23]);
        }
        boolean doReplace = dkgt.getReplaceFonts();
        String s1 = dkgt.getOldFont();
        String s2 = dkgt.getNewFont();
        if(doReplace) {
            if((s1 == null) || (s2 == null)) {
                doReplace = false;
            } else {
                s1 = s1.trim(); s2 = s2.trim();
                if((s1.length() == 0) || (s2.length() == 0)) {
                    doReplace = false;
                }
            }
        }
        if(doReplace) {
            cbReplace1.setSelected(true);
            tReplace1.setText(s1);
            tReplace2.setText(s2);
        } else {
            cbReplace1.setSelected(false);
            tReplace1.setText(t[23]);
            tReplace2.setText(t[23]);
        }
    }

    /**
     * Transfer data from dialog to DkGuiTool object.
     */
    public void dataPut() {
        int b = 0;
        String s;
        dkgt.setLafIndex(cbLAF.getSelectedIndex());
        try {
            b = Integer.parseInt(tMinimum.getText().trim());
        } catch(Exception e) { b = 0; }
        b = 5;
        try {
            b = Integer.parseInt(tBorder.getText().trim());
        } catch(Exception e) { b = 5; }
        dkgt.setComponentBorder(b);
        if(!cbMinimum.isSelected()) {
            b = 0;
        } else {
            try {
                b = Integer.parseInt(tMinimum.getText().trim());
            } catch(Exception e) { b = 0; }
        }
        dkgt.setMinimumFontSize(b);
        boolean replaceFonts = cbReplace1.isSelected();
        dkgt.setReplaceFonts(replaceFonts);
        s = t[23];
        try {
            s = tReplace1.getText().trim();
        } catch(Exception e) { s = t[23]; }
        dkgt.setOldFont(s);
        s = t[23];
        try {
            s = tReplace2.getText().trim();
        } catch(Exception e) { s = t[23]; }
        dkgt.setNewFont(s);
        b = cbSaveStage.getSelectedIndex();
        boolean sys = cbSystemSave.isSelected();
        dkgt.save(b, sys);
    }


    /** Set default values. */
    private void setDefaults() {
        cbLAF.setSelectedIndex(0);
        tBorder.setText(t[24]);
        tMinimum.setText(t[25]);
        cbMinimum.setSelected(true);
        cbReplace1.setSelected(false);
        tReplace1.setText(t[23]);
        tReplace2.setText(t[23]);
        cbSaveStage.setSelectedIndex(0);
        cbSystemSave.setSelected(false);
    }


    /** Show information about the used fonts. */
    private void showFontInformation() {
        String text;
        StringBuilder sb = new StringBuilder();
        sb.append(t[26]);
        sb.append(dkgt.getFontsBeforeReplacement());
        sb.append(t[27]);
        sb.append(dkgt.getFontsAfterReplacement());
        sb.append(t[28]);
        text = new String(sb);
        try {
            JOptionPane.showMessageDialog(
                this, text, t[29], JOptionPane.INFORMATION_MESSAGE
            );
        } catch(Exception e) {}
    }


    /** Indices of texts which appear as action commands. */
    private int[] textsToCheck = {
        14, 15, 16, 17, 22
    };

    /**
     * Reaction on mouse click.
     * @param e The action event.
     */
    @Override
    public void actionPerformed(ActionEvent e) {
        String s = e.getActionCommand();
        int i = dkt.getStringArrayIndex(t, s, textsToCheck);
        switch(i) {
            case 14: {  // OK
                dataPut();
                setModal(false);
                try {
                    JOptionPane.showMessageDialog(
                        this, t[30], t[31], JOptionPane.INFORMATION_MESSAGE
                    );
                } catch(Exception exc) {}
                setVisible(false);
            } break;
            case 15: {  // Cancel
                dataGet();
                setModal(false);
                setVisible(false);
            } break;
            case 16: {  // Reset
                dataGet();
                invalidate();
            } break;
            case 17: {  // Defaults
                setDefaults();
                invalidate();
            } break;
            case 22: {
                showFontInformation();
            } break;
        }
    }
}
