/*
Copyright (c) 2009, Dirk Krause
All rights reserved.

Redistribution and use in source and binary forms,
with or without modification, are permitted provided
that the following conditions are met:

* Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.
* Redistributions in binary form must reproduce the above
  opyright notice, this list of conditions and the following
  disclaimer in the documentation and/or other materials
  provided with the distribution.
* Neither the name of the Dirk Krause nor the names of
  contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE.
*/

package dirk_krause.tools;

// jlayout.import.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Dimension;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JButton;
import javax.swing.JEditorPane;
import javax.swing.WindowConstants;
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.import.end


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.Dimension;
import java.awt.Toolkit;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.text.Document;
import java.net.URL;

/**
 * Dialog to show online help, version and license, etc.
 * @author krause
 */
public class MessageDialog
	extends JDialog
	implements ActionListener, WindowListener
{

    /** Parent JFrame. */
    private JFrame parent = null;

    /** DkTool object. */
    private DkTool dkt = null;

    /** DkGuiTool object. */
    private DkGuiTool dkgt = null;

    /** Border (space between GUI components). */
    private int b = 5;

    /** Text for the OK button. */
    private String textOK = "OK";

    /** Empty text (default text shown). */
    private String emptyText = "";

    /** Dialog box title. */
    private String titleText = "Log";

    /** Content type for message. */
    private static final String[] contentTypes = {
	"text/plain",	//  0
	"text/html"	//  1
    };


// jlayout.variables.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	JButton bOK = null;
	JPanel pButton = null;
	JPanel pa = null;
	JScrollPane sp = null;
	JEditorPane tMsg = null;
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.variables.end


// jlayout.setup.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	/**
	 * Create GridBag constraints for a component.
	 *
	 * @param x
	 * The start grid column of the component.
	 *
	 * @param y
	 * The start grid line of the component.
	 *
	 * @param w
	 * The width of the component in grid columns.
	 *
	 * @param h
	 * The height of the component in grid lines.
	 *
	 * @param f
	 * The fill information (horizontal, vertical, both).
	 *
	 * @param wx
	 * The weight factor to grow the component horizontally
	 * when the container grows.
	 *
	 * @param wy
	 * The weight factor to grow the component vertically
	 * when the container grows.
	 */
	private GridBagConstraints jLayoutGbc(
	  int x, int y, int w, int h, int f, int a, double wx, double wy
	) {
	  GridBagConstraints back = new GridBagConstraints();
	  back.gridx = x;
	  back.gridy = y;
	  back.gridwidth = w;
	  back.gridheight = h;
	  back.fill = f;
	  back.anchor = a;
	  back.weightx = wx;
	  back.weighty = wy;
	  return back;
	}
	/**
	 * Create a dummy panel to ensure minimum distances.
	 *
	 * @param b
	 * The panels width and hight.
	 *
	 * @param rms
	 * A flag to indicate whether or not the panel must
	 * be set exactly to the given size (The panel can not grow).
	 */
	protected JPanel jLayoutCreateDistancePanel(int b, boolean rms)
	{
	  JPanel back = new JPanel();
	  Dimension d = new Dimension(b, b);
	  back.setMinimumSize(d);
	  back.setPreferredSize(d);
	  if(rms) {
	    back.setMaximumSize(d);
	  }
	  return back;
	}
	private void jLayoutSetup()
	{
	  // bOK 31
	  bOK = new JButton(textOK);
	  // pButton 17
	  pButton = new JPanel();
	  {
	    pButton.setLayout(new BoxLayout(pButton, BoxLayout.LINE_AXIS));
	    pButton.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButton.add(Box.createHorizontalGlue());
	    pButton.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButton.add(bOK);
	    pButton.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButton.add(Box.createHorizontalGlue());
	    pButton.add(Box.createRigidArea(new Dimension(b, 0)));
	  }
	  // tMsg 20
	  tMsg = new JEditorPane();
	  tMsg.setText(emptyText);
	  // sp 16
	  sp = new JScrollPane(tMsg);
	  // pa 12
	  pa = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pa.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      2, 4, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(sp, gbc);
	    pa.add(sp);
	    gbc = jLayoutGbc(
	      1, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pButton, gbc);
	    pa.add(pButton);
	  }
	  // MAIN 0
	  setTitle(titleText);
	  setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
	  {
	    Container cp = null;
	    cp = getContentPane();
	    GridBagLayout gbl = new GridBagLayout();
	    cp.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      2, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pa, gbc);
	    cp.add(pa);
	  }
	  bOK.addActionListener(this);
	}
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.setup.end

// jlayout.cleanup.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	private void jLayoutCleanup()
	{
	  bOK.removeActionListener(this);
	}
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.cleanup.end

        /**
         * Constructor.
         * @param p Parent JFrame.
         * @param d DkTool object.
         * @param g DkGuiTool object.
         */
    public MessageDialog(JFrame p, DkTool d, DkGuiTool g) {
        super(p);
        parent = p; dkt = d; dkgt = g; b = dkgt.getComponentBorder();
        jLayoutSetup();
        tMsg.setContentType(contentTypes[1]);
        tMsg.setEditable(false);
        sp.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        sp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
	Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
	int w = dim.width * 3 / 4;
	int h = dim.height * 3 / 4;
	sp.setPreferredSize(new Dimension(w, h));
	sp.setMinimumSize(new Dimension(10, 10));
        pack();
    }

    /**
     * Set text to show.
     * @param newtext   New text.
     */
    public void setEditorText(String newtext) {
        tMsg.setEditable(true);
        tMsg.setText(newtext);
        tMsg.setEditable(false);
    }


    /**
     * Set page for editor.
     * @param newpage
     * @return Flag to indicate success.
     */
    public boolean setEditorPage(String newpage) {
        boolean back = true;
        tMsg.setEditable(true);
        try {
            tMsg.setPage(newpage);
        } catch(Exception e) { back = false; }
        tMsg.setEditable(false);
        return back;
    }

    /**
     * Set URL of text document to show.
     * @param newurl    URL of document to be shown.
     * @return          Flag to indicate success.
     */
    public boolean setEditorPage(URL newurl) {
        boolean back = true;
        tMsg.setEditable(true);
        try {
            tMsg.setPage(newurl);
            /*
            Document doc = tMsg.getDocument();
            if(doc != null) {
                System.out.println("DEBUG: Can change property");
                doc.putProperty(Document.StreamDescriptionProperty, null);
            }
             */
        } catch(Exception e) { back = false; }
        tMsg.setEditable(false);
        return back;
    }


    /**
     * Set text contents type.
     * @param f Flag: HTML (true) or plain text (false).
     */
    public void setHtml(boolean f) {
        tMsg.setContentType(contentTypes[f ? 1 : 0]);
    }

    /** Cleanup. */
    public void cleanup() {
        jLayoutCleanup();
    }

    /**
     * Close (hide) window on OK.
     * @param e Action event from OK button.
     */
    @Override
    public void actionPerformed(ActionEvent e) {
        setModal(false);
	setVisible(false);
    }

    /**
     * Close (hide) window on window close event.
     */
    @Override
    public void windowClosing(WindowEvent e)
    {
        setModal(false);
        setVisible(false);
    }

    /** Unused event handler */
    @Override
    public void windowActivated(WindowEvent e) {}

    /** Unused event handler */
    @Override
    public void windowClosed(WindowEvent e) {}

    /** Unused event handler */
    @Override
    public void windowDeactivated(WindowEvent e) {}

    /** Unused event handler */
    @Override
    public void windowDeiconified(WindowEvent e) {}

    /** Unused event handler */
    @Override
    public void windowIconified(WindowEvent e) {}

    /** Unused event handler */
    @Override
    public void windowOpened(WindowEvent e) {}

}

